<?php
namespace Avaliacao\Logic\AvaliacaoPesquisa;

use Avaliacao\Entities\Agrupquestaval;
use Avaliacao\Entities\Agrupquestpadr;
use Avaliacao\Entities\Avaliacaogeral;
use Avaliacao\Entities\AvlFontedados;
use Avaliacao\Entities\AvlItemavalfilial;
use Avaliacao\Entities\AvlLocalavalfilial;
use Avaliacao\Entities\AvlPadravalfilial;
use Avaliacao\Entities\AvlRespquestaval;
use Avaliacao\Entities\Combquestaval;
use Avaliacao\Entities\Combquestpadr;
use Avaliacao\Entities\Execavaliacao;
use Avaliacao\Entities\Padravaliacao;
use Avaliacao\Entities\Questao;
use Avaliacao\Entities\Questavaliacao;
use Avaliacao\Entities\Questpadraval;
use Avaliacao\Entities\Respavaliacao;
use Avaliacao\Entities\Resposta;
use Geral\Entities\Avaliacao;
use Geral\Entities\Tiporelaciona;
use Geral\Util\DateUtil;
use Planejamento\Entities\Cardadia;
use Setforms2\Runtime\Helper\Procedure;
use Setforms2\Runtime\Helper\Procedure\Param;
use Avaliacao\Entities\AvlParametrogeral;
use Avaliacao\Entities\AvlServicoitemaval;
use Avaliacao\Entities\AvlServicoaval;
use Avaliacao\Entities\Apuragrupaval;
use Geral\Util\NovoCodigo;
use HCM\Util\FPA;
use \Geral\Util\Ambiente;

class AvaliacaoPesquisa {

    const NRCOMB_PADRAO = '1';

    public static $nrcombquestaval;
    public static $nrquestao;
    public static $txquestao;
    public static $txcomplementoquestao;
    public static $nrtemaanalise;
    private $_vinculom;

    private $funcionariosSemFaixa;
    
    public function getFuncionariosSemFaixa() 
    {
        return $this->funcionariosSemFaixa;
    }
    
    public static $mensagensAcumuladas;

    public static function getNrCombQuestAval(){
        return  self::$nrcombquestaval;
    }

    public static function setNrCombQuestAval($nrcombinacaoquestao){
        self::$nrcombquestaval = $nrcombinacaoquestao;
    }

    public static function getNrQuestao(){
        return self::$nrquestao;
    }

    public static function setNrQuestao($nrquestao){
        self::$nrquestao = $nrquestao;
    }

    public static function getNmQuestao(){
        return self::$txquestao;
    }

    public static function setNmQuestao($txquestao){
        self::$txquestao = $txquestao;
    }

    public static function getTxComplementoQuestao(){
        return self::$txcomplementoquestao;
    }

    public static function setTxComplementoQuestao($txcomplemquestao){
        self::$txcomplementoquestao= $txcomplemquestao;
    }

    public static function getNrTemaAnalise() {
        return self::$nrtemaanalise;
    }

    public static function setNrTemaAnalise($nrtemaanalise){
        self::$nrtemaanalise= $nrtemaanalise;
    }


    public static function geraExecAvaliacao($nrorg,
                                             $cdoperador,
                                             $nravaliacao,
                                             $nrparcnegocio,
                                             $cdcliente,
                                             $cdconsumidor,
                                             $dtexecucaoaval) {
        $procedure = new Procedure('AVL_GERA_EXECAVALIACAO');
        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAVALIACAO', Param::PARAM_INPUT, $nravaliacao, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_NRPARCNEGOCIO', Param::PARAM_INPUT, $nrparcnegocio, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $cdcliente, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONSUMIDOR', Param::PARAM_INPUT, $cdconsumidor, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTEXECUCAOAVAL', Param::PARAM_INPUT_OUTPUT, $dtexecucaoaval, Param::PARAM_TYPE_STR, 30));
        $execavaliacao = $procedure->call();
        return $execavaliacao['P_DTEXECUCAOAVAL'];
    }

    public static function gravaRespAvaliacao($nrorg,
                                              $cdoperador,
                                              $nrrespavaliacao,
                                              $nrexecavaliacao,
                                              $nrresposta,
                                              $txrespavaliacao,
                                              $dtrespavaliacao,
                                              $vrrespavaliacao,
                                              $txobscorrecaval,
                                              $vrnotarespaval) {
        $procedure = new Procedure('AVL_GRAVA_RESPAVALIACAO');
        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRRESPAVALIACAO', Param::PARAM_INPUT_OUTPUT, $nrrespavaliacao, Param::PARAM_TYPE_INT, 30));
        $procedure->addParam(new Param('P_NREXECAVALIACAO', Param::PARAM_INPUT, $nrexecavaliacao, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_NRRESPOSTA', Param::PARAM_INPUT, $nrresposta, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_TXRESPAVALIACAO', Param::PARAM_INPUT, $txrespavaliacao, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTRESPAVALIACAO', Param::PARAM_INPUT, $dtrespavaliacao, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRRESPAVALIACAO', Param::PARAM_INPUT, $vrrespavaliacao, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TXOBSCORRECAVAL', Param::PARAM_INPUT, $txobscorrecaval, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRNOTARESPAVAL', Param::PARAM_INPUT, $vrnotarespaval, Param::PARAM_TYPE_INT));
        $respavaliacao = $procedure->call();
        return $respavaliacao['P_NRRESPAVALIACAO'];
    }

    public static function AVL_GRAVA_AVL_RESPQUESTAVAL($nrorg, $cdoperador, $nravaliacao) {
        $procedure = new Procedure('AVL_GRAVA_AVL_RESPQUESTAVAL');
        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAVALIACAO', Param::PARAM_INPUT, $nravaliacao, Param::PARAM_TYPE_INT, 30));
        $avaliacao = $procedure->call();
    }

    public static function validaDataLimiteInclusaoAvaliacao($nrorg, $data_avaliacao){
        $data_avaliacao = new \TkDateTime($data_avaliacao);

        $obj_ParametroGeral = new AvlParametrogeral();
        /** @var $ParametroGeral AvlParametrogeral */
        $ParametroGeral = $obj_ParametroGeral->retornaParametrosGerais($nrorg);
        $dia_limite = $ParametroGeral->getDilimitepesqmesanterior();
        $data_atual = new \TkDateTime(null, \TkDateTime::FORMAT_DATE);

        $mes_atual = $data_atual->toString('M');
        $ano_atual = $data_atual->toString('Y');

        $data_limite = new \TkDateTime($dia_limite.'/'.$mes_atual.'/'.$ano_atual);

        $data_aux = new \TkDateTime($dia_limite.'/'.$mes_atual.'/'.$ano_atual);
        //mes anterior
        $data_aux->subMonth(1);
        $mes_anterior = $data_aux->toString('M');
        //primeiro dia do mes anterior
        $data_aux->setDay(1);
        $primeiro_dia_mes = $data_aux->toString(\TkDateTime::DAY);
        //ultimo dia do mes anterior
        $data_aux->addMonth(1)->subDay(1);
        $ultimo_dia_mes = $data_aux->toString(\TkDateTime::DAY);
        $inicio_mes_anterior = new \TkDateTime($primeiro_dia_mes.'/'.$mes_anterior.'/'.$ano_atual);
        $fim_mes_anterior = new \TkDateTime($ultimo_dia_mes.'/'.$mes_anterior.'/'.$ano_atual);

        //Valida apenas para avaliacoes com data antes do fim do mes anterior...
        if ($data_avaliacao->isEarlier($fim_mes_anterior) || $data_avaliacao->equals($fim_mes_anterior)) {
            //... e tambem se a data da avaliacao e maior que a data de inicio de mes anterior
            if ($data_avaliacao->isLater($inicio_mes_anterior) || $data_avaliacao->equals($inicio_mes_anterior)){
                //Verifica se a data atual esta dentro da data limite
                if ($data_atual->isEarlier($data_limite) || $data_atual->equals($data_limite)) return true; return $dia_limite;
            }
            return $dia_limite;
        }
        return true;

    }

    public static function incluiServicoAvalicao($nrorg, $nravaliacao, $item_avaliacao, $filial) {
        $obj_ServicoItemAval = new AvlServicoitemaval();
        $obj_Servicoaval = new AvlServicoaval();
        $ServicoItemAval = $obj_ServicoItemAval->retornaServicosPorItemAvaliacao($nrorg, $filial, $item_avaliacao);
        if (is_array($ServicoItemAval)) {
            /** @var $servico AvlServicoitemaval */
            foreach ($ServicoItemAval as $servico) {
                $cdservico = $servico->getCdservfili();
                /** @var $servicoAval AvlServicoaval */
                $servicoAval = $obj_Servicoaval->retornaServicoAvaliacao($nrorg, $nravaliacao, $filial, $cdservico);
                if (!is_object($servicoAval)) {
                    $obj_Servicoaval->insereServicoAvaliacao($nrorg, $nravaliacao, $filial, $cdservico);
                }
            }
        }
    }

    public static function excluiServicosAvaliacao($nrorg, $nravaliacao){
    try {
        AvlServicoaval::getRepository()->excluiServicosAvaliacao($nrorg, $nravaliacao);
        return true;
    } catch(\Exception $e) {
        return false;
    }
}

    public static function incluiCombinacaoQuestao(
        $nrorg,
        $nravaliacao,
        $nrpadravaliacao,
        $lancamento = 'MANUAL',
        $dados_importacao = array()
    ){
        $CombQuestPadr = new Combquestpadr();
        $QuestPadrAval = new Questpadraval();
        $AgrupQuestPadr = new Agrupquestpadr();

        //consulta combinacoes de questoes padrao
        $CombQuestPadr = $CombQuestPadr->retornaCombQuestPadrao($nrorg, $nrpadravaliacao);

        if (is_array($CombQuestPadr)) {
            /** @var $CombinacaoPadrao Combquestpadr */
            foreach ($CombQuestPadr as $CombinacaoPadrao) {
                $contador_importacao = 0;
                //dados da combinacao de questoes padrao
                $nome_combinacao = $CombinacaoPadrao->getNmcombquestpadr();
                $id_default = $CombinacaoPadrao->getIddefault();

                $CombinacaoAvaliacao = new Combquestaval();
                //insere combinacao de questoes da avaliacao
                $CombinacaoAvaliacao = $CombinacaoAvaliacao->insereCombQuestAval(
                    $nrorg,
                    $nravaliacao,
                    $nome_combinacao,
                    $id_default
                );

                //codigo da combinacao de questoes padrao
                $nrcombquestpadr = $CombinacaoPadrao->getNrcombquestpadr();

                //consulta questoes padrao
                $QuestPadrAval = $QuestPadrAval->retornaQuestPadrAval($nrorg, $nrcombquestpadr);
                if (is_array($QuestPadrAval)) {
                    /** @var $QuestaoPadrao Questpadraval */
                    foreach ($QuestPadrAval as $QuestaoPadrao) {
                        $contador_importacao ++;
                        //dados da questao padrao
                        $nrquestao = $QuestaoPadrao->getNrquestao();
                        $ordenacao = $QuestaoPadrao->getNrordequestpadr();
                        $nrtemaanalise = $QuestaoPadrao->getNrtemaanalise();
                        $txcomplementoquestao = $QuestaoPadrao->getTxcomplementoquestao();

                        //codigo da combinacao de questoes da avaliacao que foi criada
                        $nrcombquestaval = $CombinacaoAvaliacao->getNrcombquestaval();

                        $QuestaoAvaliacao = new Questavaliacao();
                        //insere questao da avaliacao
                        $QuestaoAvaliacao->insereQuestavaliacao(
                            $nrorg,
                            $nrcombquestaval,
                            $nrquestao,
                            $ordenacao,
                            $nrtemaanalise
                        );

                        if ($contador_importacao === 1 && $lancamento === 'IMPORTACAO') {
                            //armazena dados que serao utilizados posteriormente
                            self::setNrCombQuestAval($nrcombquestaval);
                            self::setNrQuestao($nrquestao);
                            self::setTxComplementoQuestao($txcomplementoquestao);
                            self::setNrTemaAnalise($nrtemaanalise);

                            //verifica se o voto ja foi importado
                            $data_voto = $dados_importacao[1];
                            $hora_voto = $dados_importacao[2];
                            $cod_fonte_dados = $dados_importacao[3];
                            $execAvaliacao = Execavaliacao::retornaExecAvaliacao(
                                $nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $nrtemaanalise, $data_voto.' '.$hora_voto, $cod_fonte_dados);
                            if (!empty($execAvaliacao)) return 'VOTO_JA_IMPORTADO';

                        } elseif ($lancamento === 'MANUAL') {
                            //armazena dados que serao utilizados posteriormente
                            self::setNrCombQuestAval($nrcombquestaval);
                            self::setNrQuestao($nrquestao);
                            self::setTxComplementoQuestao($txcomplementoquestao);
                            self::setNrTemaAnalise($nrtemaanalise);
                        }

                        self::gravaRespostasAvaliacao($nrorg, $nravaliacao);

                        if ($contador_importacao === 1 && $lancamento === 'IMPORTACAO') {
                            $retorno = self::preparaImportacaoVotos($nrorg, $nravaliacao, $dados_importacao);
                            if ($retorno === false) {
                                return 'SEM_COD_INTEGRACAO';
                            }
                        }
                    }
                }
            }
        }
    }

    public function calculaTotalParticipantePrevistos($nrorg, $nravaliacao, $cdfilial, $item_avaliacao, $data_realizada) {
        $obj_ServicoAval = new AvlServicoaval();
        $obj_ServicoItemAval = new AvlServicoitemaval();
        $obj_Cardadia = new Cardadia();

        $obj_ServicoAval = $obj_ServicoAval->retornaServicosPorAvaliacao($nrorg, $nravaliacao);

        //Calcula a qtd. total de participantes prevista com base no efetivos do planejamento
        if (is_array($obj_ServicoAval)) {
            $qt_efetivos = 0;
            /** @var $servicoAval AvlServicoaval */
            foreach ($obj_ServicoAval as $servicoAval) {
                $cdservico = $servicoAval->getCdservfili();
                $ServicoItemAval = $obj_ServicoItemAval->retornaServicoItemAval($nrorg, $cdfilial, $cdservico, $item_avaliacao);
                if(is_object($ServicoItemAval)){
                    /** @var $ServicoItemAval AvlServicoitemaval */
                    if ($ServicoItemAval->getIdsomaefetivosaval() === 'S') {
                        $obj_Cardadia = $obj_Cardadia->retornaCardadia($nrorg, $cdfilial, $cdservico, $data_realizada);
                        if (is_object($obj_Cardadia)) {
                            $qt_efetivos += $obj_Cardadia->getQtcomefetcar();

                        } else {
                            //se nao existir cardapio na data realizada para algum servico
                            return 'SEM_CARDAPIO';
                        }
                    }
                }
                else{
                    return tk_warning('Não possui efetivos.');
                }
            }

            return $qt_efetivos;
        } else {
            return 'SEM_SERVICO';
        }
    }

    public static  function gravaRespostasAvaliacao($nrorg, $nravaliacao, $nrquestao=null, $txcomplementoquestao=null, $nrtemaanalise=null){
        $nrquestao = ($nrquestao) ? $nrquestao : self::getNrQuestao();
        $txcomplementoquestao = ($txcomplementoquestao)? $txcomplementoquestao : self::getTxComplementoQuestao();
        $nrtemaanalise = ($nrtemaanalise) ? $nrtemaanalise : self::getNrTemaAnalise();

        $obj_RespQuestAval = new AvlRespquestaval();
        /** @var $respostasAvaliacao AvlRespquestaval */
        $respostasAvaliacao = $obj_RespQuestAval->retornaRespQuestAval($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $nrtemaanalise);
        if (empty($respostasAvaliacao)) {
            $obj_Resposta = new Resposta();
            $obj_Resposta = $obj_Resposta->retornaRespostaByQuestao($nrorg, $nrquestao);

            /** @var $Resposta Resposta */
            foreach ($obj_Resposta as $Resposta) {
                $obj_RespQuestAval->incluiRespostasAvaliacao($nrorg, $nravaliacao, $Resposta->getNrresposta(), 0, $txcomplementoquestao, $nrtemaanalise);
            }

        }

    }

    public function preparaImportacaoVotos($nrorg, $nravaliacao, $dados_importacao) {
        $id_voto = $dados_importacao[0];
        $data_voto = $dados_importacao[1];
        $hora_voto = $dados_importacao[2];
        $fonte_dados = $dados_importacao[3];
        $nrquestao = $this->getNrQuestao();
        $txcomplementoquestao = $this->getTxComplementoQuestao();
        $tema_analise = $this->getNrTemaAnalise();

        $obj_Resposta = new Resposta();
        $obj_Resposta = $obj_Resposta->retornaRespostaByCodIntegracao($nrorg, $nrquestao, $id_voto);

        if (is_object($obj_Resposta)) {
            self::excluiExecAvaliacaoManual($nrorg, $nravaliacao);
            $this->importaVotos($nrorg, $nravaliacao, $id_voto, $data_voto, $hora_voto, $fonte_dados);
            return true;
        } else {
            $obj_Questao = new Questao();
            $obj_Questao->retornaQuestao($nrorg, $nrquestao);
            $this->setNmQuestao($obj_Questao->getTxquestao());

            $execAvaliacao = Execavaliacao::retornaExecAvaliacao($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise, $data_voto.' '.$hora_voto, $fonte_dados);
            if (is_array($execAvaliacao)) {
                for ($i=0; $i<count($execAvaliacao); $i++) {
                    $nrexecavaliacao = $execAvaliacao[0]['NREXECAVALIACAO'];
                    Respavaliacao::excluiRespAvaliacao($nrorg, $nrexecavaliacao);
                }
                Execavaliacao::excluiExecAvaliacao($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise, $fonte_dados);
            }
            return false;
        }
    }

    public function importaVotos(
        $nrorg,
        $nravaliacao,
        $cd_integracao_voto,
        $data_voto,
        $hora_voto,
        $fonte_dados
    ){
        $nrcombinacao = $this->getNrCombQuestAval();
        $nrquestao = $this->getNrQuestao();
        $txcomplementoquestao = $this->getTxComplementoQuestao();
        $tema_analise = $this->getNrTemaAnalise();

        $obj_ExecAvaliacao = new Execavaliacao();
        $obj_ExecAvaliacao = $obj_ExecAvaliacao->executaAvaliacao(
            $nrorg, $nravaliacao, $nrcombinacao, $nrquestao, $txcomplementoquestao, $tema_analise, $data_voto.' '.$hora_voto, $fonte_dados);
        $nrexecavaliacao = $obj_ExecAvaliacao->getNrexecavaliacao();
        /** @var $obj_Resposta Resposta */
        $obj_Resposta = new Resposta();
        $obj_Resposta = $obj_Resposta->retornaRespostaByCodIntegracao($nrorg, $nrquestao, $cd_integracao_voto);
        $nrresposta = $obj_Resposta->getNrresposta();

        $obj_RespAvaliacao = new Respavaliacao();
        $obj_RespAvaliacao->gravaRespostasAvaliacao($nrorg, $nrexecavaliacao, $nrresposta);

        $txcomplementoquestao = ($txcomplementoquestao) ? " = '$txcomplementoquestao'" : 'IS NULL';
        $tema_analise = ($tema_analise) ? ' = '.$tema_analise : 'IS NULL';
        $qt_votos = $obj_RespAvaliacao->retornaQuantVotosPorResposta($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise, $nrresposta);
        $qt_votos = $qt_votos[0]['QT_VOTOS'];

        $obj_RespQuestAval = new AvlRespquestaval();
        //Grava a quantidade de votos por resposta da questao para a avaliacao
        $txcomplementoquestao = ($txcomplementoquestao) ? " AND TXCOMPLEMENTOQUESTAO = '{$txcomplementoquestao}'" : " AND TXCOMPLEMENTOQUESTAO IS NULL";
        $tema_analise = ($tema_analise) ? " AND NRTEMAANALISE = {$tema_analise}" : " AND NRTEMAANALISE IS NULL";
        $obj_RespQuestAval->incrementaQuantidadeVotosAvaliacao($nrorg, $nravaliacao, $txcomplementoquestao, $tema_analise, $nrresposta, $qt_votos);

    }

    public static function excluiExecAvaliacaoManual($nrorg, $nravaliacao){
        try {
            Execavaliacao::getRepository()->excluiExecAvaliacaoManual($nrorg, $nravaliacao);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }

    public static function excluiRespQuestAval($nrorg, $nravaliacao){
        try {
            AvlRespquestaval::getRepository()->query_excluiRespQuestAval($nrorg, $nravaliacao);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }

    public static function criaAvaliacoesPorData($nrorg, $filial, $data_inicial, $data_final, $nrpadravaliacao) {
        $obj_ItemAvalFilial = new AvlItemavalfilial();
        $obj_LocalAvalFilial = new AvlLocalavalfilial();
        $obj_QuestionarioFilial = new AvlPadravalfilial();
        $obj_Padravaliacao = new Padravaliacao();
        $obj_AvaliacaoGeral = new Avaliacaogeral();
        for ($data_avaliacao = new \TkDateTime($data_inicial); ($data_avaliacao->isEarlier($data_final) || $data_avaliacao->equals($data_final)); $data_avaliacao->addDay(1)) {
            $dia_limite = self::validaDataLimiteInclusaoAvaliacao($nrorg, $data_avaliacao);
            if ($dia_limite === true){ // true
                $data_vigencia_atual_item_aval = $obj_ItemAvalFilial->retornaMaiorDataVigenciaItem($nrorg, $filial);
                if (($data_vigencia_atual_item_aval[0]['MAIOR']) !== null) {
                    $data_vigencia_atual_item_aval = new \TkDateTime($data_vigencia_atual_item_aval[0]['MAIOR']);
                    $data_vigencia_atual_item_aval = $data_vigencia_atual_item_aval->toString(\TkDateTime::FORMAT_DATE);

                    $itens_avaliacao = $obj_ItemAvalFilial->retornaItemAvaliacaoFilial($nrorg, $filial, $data_vigencia_atual_item_aval);
                    if (is_array($itens_avaliacao)) {//é array
                        /** @var $itemAvaliacao AvlItemavalfilial */
                        foreach ($itens_avaliacao as $itemAvaliacao) {
                            $nritemavaliacao = $itemAvaliacao->getNritemavaliacao();//38
                            $lista_locais_avaliacao = array();
                            $nrlocalavaliacao = $itemAvaliacao->getNrlocalavaliacao();//23
                            if (!empty($nrlocalavaliacao)) {
                                $lista_locais_avaliacao[] = $nrlocalavaliacao;

                            } else {
                                $locais_filial = $obj_LocalAvalFilial->retornaLocaisFilial($nrorg, $filial);
                                if (is_array($locais_filial)) {
                                    /** @var $local_filial AvlLocalavalfilial */
                                    foreach ($locais_filial as $local_filial) {
                                        $nrlocalavaliacao = $local_filial->getNrlocalavaliacao();
                                        $lista_locais_avaliacao[] = $nrlocalavaliacao;
                                    }
                                } else {
                                    tk_warning('Filial não possui Local de avaliação parametrizado.');
                                }
                            }

                            $data_vigencia_atual_quest = $obj_QuestionarioFilial->retornaMaiorDataVigenciaQuestionario($nrorg, $filial, $nrpadravaliacao);
                            if (($data_vigencia_atual_quest[0]['MAIOR']) !== null) {
                                $data_vigencia_atual_quest = new \TkDateTime($data_vigencia_atual_quest[0]['MAIOR']);
                                $data_vigencia_atual_quest = $data_vigencia_atual_quest->toString(\TkDateTime::FORMAT_DATE);

                                $questionarios = $obj_QuestionarioFilial->retornaQuestionarioFilial($nrorg, $filial, $data_vigencia_atual_quest, $nritemavaliacao);
                                if (is_array($questionarios)) {
                                    /** @var $questionario AvlPadravalfilial */
                                    foreach ($questionarios as $questionario) {
                                        $nrquestionario = $questionario->getNrpadravaliacao();
                                        /** @var $Padravaliacao Padravaliacao */
                                        $Padravaliacao = $obj_Padravaliacao->retornaPadraoAvaliacao($nrorg, $nrquestionario);
                                        $nrtipoavaliacao = $Padravaliacao->getNrtipoavaliacao();//19
                                        $nmavaliacao = $Padravaliacao->getNmpadravaliacao();
                                        $dataInicial = $data_avaliacao->toString(\TkDateTime::FORMAT_DATE);
                                        foreach ($lista_locais_avaliacao as $nrlocalavaliacao) {
//                                            $nrlocalavaliacao = $lista_locais_avaliacao[$i];

                                            $consulta_AvaliacaoGeral = $obj_AvaliacaoGeral->retornaAvaliacaoGeral(
                                                $nrorg,
                                                $filial,
                                                $dataInicial,
                                                $nrlocalavaliacao,
                                                $nritemavaliacao,
                                                $nrquestionario,
                                                $nrtipoavaliacao);

                                            /** @var $consulta_AvaliacaoGeral Avaliacaogeral */
                                            if ((!is_object($consulta_AvaliacaoGeral)) ||
                                                (is_object($consulta_AvaliacaoGeral) && $consulta_AvaliacaoGeral->getIdsituacaoavaliacao() === 'CANCELADA')) {
                                                $obj_AvaliacaoGeral = $obj_AvaliacaoGeral->incluiAvaliacaoGeral(
                                                    $nmavaliacao,
                                                    $nrorg,
                                                    $filial,
                                                    $nrlocalavaliacao,
                                                    $dataInicial,
                                                    $nritemavaliacao,
                                                    $nrquestionario,
                                                    $nrtipoavaliacao,
                                                    'SISTEMA');
                                                if(is_object($obj_AvaliacaoGeral)){
                                                    $nravaliacao = $obj_AvaliacaoGeral->getNravaliacao();
                                                    self::incluiCombinacaoQuestao($nrorg, $nravaliacao, $nrquestionario);
                                                    self::incluiServicoAvalicao($nrorg, $nravaliacao, $nritemavaliacao, $filial);
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    return tk_warning('Atenção! Filial não possui Questionário parametrizado.');
                                }
                            } else {
                                return tk_warning('Atenção! Filial não possui período de vigência atual para questionário.');
                            }
                        }
                    } else {
                        return tk_warning('Atenção! Filial não possui Item de Avaliacao parametrizado.');
                    }
                } else {
                    return tk_warning('Atenção! Filial não possui período de vigência atual para item de avaliação.');
                }
            } else {
                return tk_warning('Atenção! A criação de avaliações do mês anterior só pode ser feita até o dia '.$dia_limite.' de cada mês');
            }
        }
        return tk_warning('As avaliações foram criadas com sucesso!');
    }

    public static  function apagaAvaliacoesPorData($nrorg, $filial, $data_inicial, $data_final) {
        for ($data_avaliacao = new \TkDateTime($data_inicial); ($data_avaliacao->isEarlier($data_final) || $data_avaliacao->equals($data_final)); $data_avaliacao->addDay(1)) {
            $obj_AvaliacaoGeral = new Avaliacaogeral();
            $string_data_avaliacao = $data_avaliacao->toString(\TkDateTime::FORMAT_DATE);
            $consulta_avaliacoes = $obj_AvaliacaoGeral->retornaAvaliacoesPorData($nrorg, $filial, $string_data_avaliacao);
            if (is_array($consulta_avaliacoes)) {
                /** @var $avaliacao Avaliacaogeral */
                foreach ($consulta_avaliacoes as $avaliacao) {
                    $id_situacao = $avaliacao->getIdsituacaoavaliacao();
                    if ($id_situacao === 'PENDENTE' || $id_situacao === 'CANCELADA') {
                        $nravaliacao = $avaliacao->getNravaliacao();
                        Respavaliacao::excluiRespostasAvaliacao($nrorg, $nravaliacao);
                        Execavaliacao::excluiExecucoesAvaliacao($nrorg, $nravaliacao);
                        Combquestaval::excluiCombinacoesQuestao($nrorg, $nravaliacao);
                        AvlRespquestaval::excluiRespostasQuestaoAvaliacao($nrorg, $nravaliacao);
                        Agrupquestaval::excluiAgrupamentosQuestao($nrorg, $nravaliacao);
                        AvlServicoaval::excluiServicosAvaliacao($nrorg, $nravaliacao);
                        Avaliacaogeral::excluiAvaliacaoGeral($nrorg, $nravaliacao);
                    }
                }
            }
        }
    }

    /**
     * Calcula a quantidade total de participantes previstos, caso o servico esteja ligado ao efetivos de planejamento
     *
     * @param $nrorg
     * @param $cdfilial
     * @param $item_trabalho
     * @param $data_realizada
     * @return int|string
     */
    public function consisteEfetivosQuantidadePrevista($nrorg, $cdfilial, $data_realizada, $questionario) {
        //A soma da quantidade prevista de participantes das pesquisas do dia deve ser igual a soma dos efetivos dos cardapios
        //dos serviços das avaliacoes para o mesmo dia.
        $obj_AvaliacaoGeral = new Avaliacaogeral();
        $resultado = $obj_AvaliacaoGeral->retornaSomaComensaisEfetivos($nrorg, $cdfilial, $data_realizada, $questionario);
        $qt_prevista = $resultado[0]['QTPREVPARTICAVAL'];
        $qt_efetivos = $resultado[0]['QTCOMEFETCAR'];
        return ($qt_prevista === $qt_efetivos);
    }

    public static function incluiPesquisaOpiniao(
                                                    $nrorg,
                                                    $filial,
                                                    $nmquestionario,
                                                    $local_avaliacao,
                                                    $id_voto,
                                                    $data_voto,
                                                    $hora_voto,
                                                    $item_avaliacao,
                                                    $cod_questionario,
                                                    $tipo_avaliacao,
                                                    $fonte_dados
                                                ){
        /** @var $obj_FonteDados AvlFontedados */
        $obj_FonteDados = new AvlFontedados();
        $obj_FonteDados = $obj_FonteDados->retornaFonteDados($nrorg, $fonte_dados);
        $cod_integracao_fonte_dados = $obj_FonteDados->getNrfontedados();

        $dados_importacao = array($id_voto, $data_voto, $hora_voto, $cod_integracao_fonte_dados);
        $obj_AvaliacaoGeral = new Avaliacaogeral();
        $consulta_AvaliacaoGeral = $obj_AvaliacaoGeral->retornaAvaliacaoGeral($nrorg,
            $filial,
            $data_voto,
            $local_avaliacao,
            $item_avaliacao,
            $cod_questionario,
            $tipo_avaliacao);

        /** @var $consulta_AvaliacaoGeral Avaliacaogeral */
        if ((is_object($consulta_AvaliacaoGeral) && $consulta_AvaliacaoGeral->getIdsituacaoavaliacao() !== 'CANCELADA')) {
            $nravaliacao = $consulta_AvaliacaoGeral->getNravaliacao();
            $obj_CombinacaoAvaliacao = new Combquestaval();
            $obj_CombinacaoAvaliacao = $obj_CombinacaoAvaliacao->retornaCombinacoesAvaliacao($nrorg, $nravaliacao);
            if (is_array($obj_CombinacaoAvaliacao)) {
                /** @var $CombinacaoAvaliacao Combquestaval */
                foreach ($obj_CombinacaoAvaliacao as $CombinacaoAvaliacao) {
                    $nrcombquestaval = $CombinacaoAvaliacao->getNrcombquestaval();
                    $obj_Questavaliacao = new Questavaliacao();
                    $obj_Questavaliacao = $obj_Questavaliacao->retornaQuestoesPorCombinacao($nrorg, $nrcombquestaval);
                    if (is_array($obj_Questavaliacao)) {
                        $contador_importacao = 0;
                        /** @var $QuestAvaliacao Questavaliacao */
                        foreach ($obj_Questavaliacao as $QuestAvaliacao) {
                            $contador_importacao++;
                            $nrquestao = $QuestAvaliacao->getNrquestao();
                            $txcomplementoquestao = $QuestAvaliacao->getTxcomplementoquestao();
                            $nrtemaanalise = $QuestAvaliacao->getNrtemaanalise();

                            //verifica se o voto ja foi importado
                            $execAvaliacao = Execavaliacao::retornaExecAvaliacao(
                                $nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $nrtemaanalise, $data_voto.' '.$hora_voto, $cod_integracao_fonte_dados);
                            if (!empty($execAvaliacao)) {
                                if ($consulta_AvaliacaoGeral->getIdsituacaoavaliacao() === 'CONCLUIDA') {
                                    return 'AVALIACAO_CONCLUIDA_VOTO_JA_IMPORTADO';
                                } else {
                                    return 'VOTO_JA_IMPORTADO';
                                }
                            } elseif ($consulta_AvaliacaoGeral->getIdsituacaoavaliacao() === 'CONCLUIDA') {
                                return 'AVALIACAO_CONCLUIDA_VOTO_NAO_IMPORTADO';
                            }

                            //armazena dados que serao utilizados posteriormente

                            self::setNrCombQuestAval($nrcombquestaval);
//                            $this->setNrCombQuestAval($nrcombquestaval);
                            self::setNrQuestao($nrquestao);
                            self::setTxComplementoQuestao($txcomplementoquestao);
                            self::setNrTemaAnalise($nrtemaanalise);

                            self::gravaRespostasAvaliacao($nrorg, $nravaliacao);

                            if ($contador_importacao === 1) {
                                $retorno = self::preparaImportacaoVotos($nrorg, $nravaliacao, $dados_importacao);
                                if ($retorno === false) {
                                    return 'SEM_COD_INTEGRACAO';
                                }
                            }
                        }
                    }
                }
            }
            //Caso não exista ou exista com status CANCELADA, criar novo registro na tabela AVALIACAOGERAL para a filial, local de avaliação e item de avaliação
        } else {
            $novaAvaliacao = $obj_AvaliacaoGeral->incluiAvaliacaoGeral($nmquestionario,
                                                                        $nrorg,
                                                                        $filial,
                                                                        $local_avaliacao,
                                                                        $data_voto,
                                                                        $item_avaliacao,
                                                                        $cod_questionario,
                                                                        $tipo_avaliacao,
                                                                        'IMPORTACAO');
            $nravaliacao = $novaAvaliacao->getNravaliacao();
            $retorno = self::incluiCombinacaoQuestao($nrorg, $nravaliacao, $cod_questionario, 'IMPORTACAO', $dados_importacao);
            if ($retorno === 'VOTO_JA_IMPORTADO') return 'VOTO_JA_IMPORTADO';
            if ($retorno === 'SEM_COD_INTEGRACAO') return 'SEM_COD_INTEGRACAO';
        }

        //Inclui servicos do item de avaliacao
        self::incluiServicoAvalicao($nrorg, $nravaliacao, $item_avaliacao, $filial);

        return 'OK';

    }
    

    public function importa_relacionamentos($nrAvaliacao, $nrorg, $cargo, $faixa = null){
        set_time_limit(100000);
        $combquestavalRepository = \Avaliacao\Entities\Combquestaval::getRepository();
        $paramsAval = array('P_NRAVALIACAO' => $nrAvaliacao);
        $nrCombQuest = $combquestavalRepository->lista_combinacaoPadrao($paramsAval);
        $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
        $tiporelacionaRepository = \Geral\Entities\Tiporelaciona::getRepository();
        //Retorna todas as relacoes entre lideres e liderados, por equipe, excluindo funcion�rios
        //com menos de 6 meses de casa, equipe do George e relacionamentos de autoavalia��o
        $paramRelacionamento = array('P_CARGO' => $cargo, 'P_NRFAIXACARGO' => $faixa);
        $funcionarioRepository = \Geral\Entities\Funcionario::getRepository();
        $sqlRelacionamento = $funcionarioRepository->retornaFuncEquipesCargo($paramRelacionamento);
        //Retorna o c�digo do Liderado (Equipe), de acordo com a tabela TIPORELACIONA (utilizado no insert)
        $paramsEquipe = array(
            'NMTIPORELACIONA' => 'Equipe'
        );
        $sqlGetNrLiderado = $tiporelacionaRepository->get_nrrelacionamento($paramsEquipe);
        
        //Retorna o c�digo do Lider, de acordo com a tabela TIPORELACIONA (utilizado no insert)
        $paramsLider = array(
                'NMTIPORELACIONA' => 'Líder'
        );
        $sqlGetNrLider = $tiporelacionaRepository->get_nrrelacionamento($paramsLider);
        
        //Retorna o c�digo da Autoavaliacao, de acordo com a tabela TIPORELACIONA (utilizado no insert)
        $paramsAutoavaliacao = array(
                'NMTIPORELACIONA' => 'Autoavaliação'
        );
        $sqlGetNrAuto = $tiporelacionaRepository->get_nrrelacionamento($paramsAutoavaliacao);
        
        //Iniciacao dos contadores para serem utilizados nos forEachs
        $count1  = 0;
        $count2  = 0;
        $count4  = 0;
        //Percorre a consulta que retorna todas as relacoes entre lideres e liderados
        foreach($sqlRelacionamento as $numkey=>$row) {

            //nr. do liderado e do lider retornado na consulta $sqlRelacionamento (utilizados no insert)
            $liderado = $row['LIDERADO'];
            $lider    = $row['LIDER'];

            if(!empty($nrAvaliacao)){
            $params2 = array('P_NRPARCEXECAVAL'     => $lider,
                             'P_NRPARCAVALIADO' => $liderado,
                             'P_NRAVALIACAO'  => $nrAvaliacao);
                 //Retorna o numero do parceiro avaliador e avaliado, de acordo com o nr. da avaliacao, nr. da combinacao, nr. do lider e do liderado
                 //retornados na consulta $sqlRelacionamento- Lider/Liderado 
                 $resultListaParticip = $participavalRepository->retornaAvaliadorEAvaliadoLiderLiderado($params2);
                 //Retorna o numero do parceiro avaliador e avaliado, de acordo com o nr. da avaliacao, nr. da combinacao, nr. do lider e do liderado
                 //retornados na consulta $sqlRelacionamento - Liderado/Lider
                 $resultListaParticipLider = $participavalRepository->retornaAvaliadorEAvaliadoLideradoLider($params2);
            }    
            $participavalEntity = new \Avaliacao\Entities\Participaval();
            //Se relacionamento (Lider/Liderado) nao existir e se relacionamento nao for autoavaliacao, eh inserido na tabela PARTICIPAVAL - relacionamento
            if (empty($resultListaParticip)) {
                $geraCodigo1 = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'PARTICIPAVAL', 1, 10, true);
                //Insert de ida (insere todos os relacionamentos do tipo Líder)
                $lista_participaval_entity = $participavalEntity->busca_participaval_unique(
                                                                                    $nrorg,
                                                                                    $nravaliacao     = $nrAvaliacao,
                                                                                    $nrparcavaliado  = $liderado,
                                                                                    $nrparcexecaval  = $lider
                                                                                    );
                if(empty($lista_participaval_entity)){
                    try {
                        $participaval =  new \Avaliacao\Entities\Participaval();
                        $participaval->insert(
                                                $nrparticipaval = $geraCodigo1,
                                                $nrorg,
                                                $nrAvaliacao,
                                                $liderado,
                                                $lider,
                                                $sqlGetNrLider[0]['NRTIPORELACIONA'],
                                                $nrCombQuestParam     = $nrCombQuest[0]['NRCOMBQUESTAVAL'],
                                                $vrresultavalia  = null,
                                                $dtinclusao      = \Geral\Util\DateUtil::getDataAtual(),
                                                $dtultatu        = null,
                                                $nrorginclusao   = $nrorg,
                                                $cdoperinclusao  = null,
                                                $nrorgultatu     = $nrorg,
                                                $cdoperultatu    = null,
                                                $cdtiporesu      = null,
                                                $dtconclusaoaval = null,
                                                $idsituacaoaval  = 'PENDENTE',
                                                $idativo         = 'S'
                                              );

                        $count1++;
                    }   catch (Exception $e) {
                            // $e->getMessage();
                         throw $e;
                        }
                    }
                }


            //Se relacionamento (Liderado/Lider) nao existir e se relacionamento nao for autoavaliacao, eh inserido na tabela PARTICIPAVAL - relacionamento
            if (empty($resultListaParticipLider)) {

                $geraCodigo2 = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'PARTICIPAVAL', 1, 10, true);
               $lista_participaval_entity = $participavalEntity->busca_participaval_unique(
                                                                                    $nrorg,
                                                                                    $nravaliacao     = $nrAvaliacao,
                                                                                    $nrparcavaliado  = $liderado,
                                                                                    $nrparcexecaval  = $lider
                                                                                    );
                if(empty($lista_participaval_entity)){
                //Insert de volta (insere todos os relacionamentos do tipo Equipe)
                try {
                    $participaval =  new \Avaliacao\Entities\Participaval();
                    $participaval->insert(
                                            $nrparticipaval = $geraCodigo2,
                                            $nrorg,
                                            $nrAvaliacao,
                                            $liderado,
                                            $lider,
                                            $sqlGetNrLiderado[0]['NRTIPORELACIONA'],
                                            $nrCombQuestParam     = $nrCombQuest[0]['NRCOMBQUESTAVAL'],
                                            $vrresultavalia  = null,
                                            $dtinclusao      = \Geral\Util\DateUtil::getDataAtual(),
                                            $dtultatu        = null,
                                            $nrorginclusao   = $nrorg,
                                            $cdoperinclusao  = null,
                                            $nrorgultatu     = $nrorg,
                                            $cdoperultatu    = null,
                                            $cdtiporesu      = null,
                                            $dtconclusaoaval = null,
                                            $idsituacaoaval  = 'PENDENTE',
                                            $idativo         = 'S');



                    $count2++;
                }   catch (\Exception $e) {
                        throw $e;
                    }
                }

              }
      }
      //Retorna o codigo de todos os liderados que fazem parte de alguma equipe
      $resultRelacLiderado = $funcionarioRepository->retornaLideradosEquipes($paramRelacionamento);
      
      foreach ($resultRelacLiderado as $numkey=>$row) {
        $liderado2 = $row['NRPARCNEGOCIO'];
        //Retorna o numero do liderado, de acordo com o nr. da avaliacao, nr. da combinacao e o nr. do liderado
        //retornado da consulta $sqlRelacLiderado (retorna false ou uma linha)
        $paramsParticipantes = array('P_NRAVALIACAO'     => $nrAvaliacao,
                                     'P_NRPARCEXECAVAL'  => $liderado2,
                                     'P_NRPARCAVALIADO'  => $liderado2);
        $sqlListaParticipAut = $participavalRepository->retornaListaParticipantes($paramsParticipantes);
        
        //Se relacionamento nao existir, eh inserido na tabela PARTICIPAVAL - relacionamento
        if ($sqlListaParticipAut == false) {
            $participavalEntity = new \Avaliacao\Entities\Participaval();
            $geraCodigo = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'PARTICIPAVAL', 1, 10, true);
           $lista_participaval_entity = $participavalEntity->busca_participaval_unique(
                                                                                $nrorg,
                                                                                $paramsParticipantes['P_NRAVALIACAO'],
                                                                                $paramsParticipantes['P_NRPARCAVALIADO'],
                                                                                $paramsParticipantes['P_NRPARCEXECAVAL']
                                                                                );

            if(empty($lista_participaval_entity)){
                            //insere todos os relacionamentos do tipo Autoavaliacao (Liderados)
            try {
                $participaval =  new \Avaliacao\Entities\Participaval();
                $participaval->insert(
                                        $nrparticipaval = $geraCodigo,
                                        $nrorg,
                                        $nrAvaliacao,
                                        $liderado       = $liderado2,
                                        $lider          = $liderado2,
                                        $sqlGetNrAuto[0]['NRTIPORELACIONA'],
                                        $nrCombQuestParam     = $nrCombQuest[0]['NRCOMBQUESTAVAL'],
                                        $vrresultavalia  = null,
                                        $dtinclusao      = \Geral\Util\DateUtil::getDataAtual(),
                                        $dtultatu        = null,
                                        $nrorginclusao   = $nrorg,
                                        $cdoperinclusao  = null,
                                        $nrorgultatu     = $nrorg,
                                        $cdoperultatu    = null,
                                        $cdtiporesu      = null,
                                        $dtconclusaoaval = null,
                                        $idsituacaoaval  = 'PENDENTE',
                                        $idativo         = 'S');
                $count4++;
            }   catch (Exception $e) {
                    throw $e;
                }
            }

        }

     }
     //total de registros inseridos
     $totalInserted = $count1 + $count2 + $count4;
     return $totalInserted;
  }
  
  /*
   * AfterInsert - importa todas as quest�es do question�rio modelo para a questavaliacao assim como os demais 
   * filhos de um questionario padrao
   */
  public static function insere_questoes_padrao_logic($nravaliacao, $newPadrao, $oldPadrao){
      $combquestavalRepository = \Avaliacao\Entities\Combquestaval::getRepository();
      $combquestpadrRepository = \Avaliacao\Entities\Combquestpadr::getRepository();
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $execavaliacaoRepository = \Avaliacao\Entities\Execavaliacao::getRepository();
      $questavaliacaoRepository = \Avaliacao\Entities\Questavaliacao::getRepository();
      $agrupquestavalRepository = \Avaliacao\Entities\Agrupquestaval::getRepository();
      $agrupquestpadrRepository = \Avaliacao\Entities\Agrupquestpadr::getRepository();
      $questpadravalRepository = \Avaliacao\Entities\Questpadraval::getRepository();
      $tiporelacpadrRepository = \Geral\Entities\Tiporelacpadr::getRepository();
      $tiporelacavalRepository = \Geral\Entities\Tiporelacaval::getRepository();
      
      $array_nravaliacao = array ('P_NRAVAL'=>$nravaliacao);

      //se o questionario foi alterado
       if ($newPadrao != $oldPadrao){
            //lista participantes da avaliacao e exibe mensagem de erro caso j� exista relacionamento para aquela avaliacao
            $sqlVerificaParticip = $participavalRepository->lista_participante_combquest($array_nravaliacao);
            if(empty($oldPadrao)){
                if ($sqlVerificaParticip) {
                    throw new \Exception('Para alterar o padrao, deve-se primeiramente excluir os relacionamentos ligados a essa avaliacao!');
                    return;
                }
            }
            $arrayNravaliacao = array('P_NRAVAL' => $nravaliacao); 
            $listaExec = $execavaliacaoRepository->busca_ExecAvaliacao($arrayNravaliacao);
            if($listaExec){
                throw new \Exception(utf8_encode('Existem avaliações concluídas para este tipo de avaliação. Operações cancelada.'));
                tk_cancel();
            }
            //verifica se estou em modo de inser��o ou atualiza��o. Se oldpadrao vier nulo, estarei inserindo
            if ($oldPadrao) {
                //Deleta questoes existentes
                $questavaliacaoRepository->delete_questaval($arrayNravaliacao);
                //Deleta Agrupamentos existentes
                $agrupquestavalRepository->delete_agrupquestaval($arrayNravaliacao);      
                //Deleta Tipos de Relacionamentos existentes
                $tiporelacavalRepository->delete_tiporelacaval($arrayNravaliacao);  
                //Deleta Combinacoes existentes
                $combquestavalRepository->delete_combquestaval($arrayNravaliacao);
            }
            //Retorna os agrupamentos de questoes
            $arrayNrpadravaliacao = array('P_NRPADRAVALIACAO' => $newPadrao); 
            $sqlAgrupPadrao = $agrupquestpadrRepository->busca_agrupquestpadr($arrayNrpadravaliacao);             
            //array vazio para ser utilizado no forEach
            $agrupQuest = array();  
            foreach($sqlAgrupPadrao as $numkey=>$row){

                //Gera Codigo de AgrupQuestAval para ser utilizado no array $agrupQuest
                $nrAgrupQuestAvaNovoCod = \Geral\Util\Novocodigo::geraCodigo(FPA::getNrorgTrabalho(),'AGRUPQUESTAVAL', 1, 10, true);
                //Array que associa o codigo do agrupamento de questao do padrao (NRAGRUPQUESTPAD - Index) com o codigo do agrupamento
                //de questao da avaliacao (NRAGRUPQUESTAVAL - Value)
                $agrupQuest[$sqlAgrupPadrao[$numkey]['NRAGRUPQUESTPAD']] = $nrAgrupQuestAvaNovoCod;

                //Insere dados na tabela de Agrupamento de Questoes da Avaliacao (AGRUPQUESTAVAL), de acordo com  a tabela AGRUPQUESTPADR
                //e com a consulta $sqlAgrupPadrao
                try {
                Agrupquestaval::insereAgrupquestavalNovo($nragrupquestava = $nrAgrupQuestAvaNovoCod,       
                                                        $nravaliacao,
                                                        $nmagrupquestava = $row['NMAGRUPQUESTPAD'],
                                                        $txagrupquestava = $row['TXAGRUPQUESTPAD'],
                                                        $nrorg = $row['NRORG'],
                                                        $idativo = $row['IDATIVO'],
                                                        $dtinclusao = DateUtil::getDataAtual(),
                                                        $dtultatu = null,
                                                        $nrorginclusao = $row['NRORG'],
                                                        $cdoperinclusao = \Geral\Util\Ambiente::getCdOperador(),
                                                        $nrorgultatu = $row['NRORG'],
                                                        $cdoperultatu = \Geral\Util\Ambiente::getCdOperador(),
                                                        $nrcriterioresul = $row['NRCRITERIORESUL']);
                }
                
                catch(Exception $e) {
                    throw tk_message('Nao foi possivel inserir dados na tab de agrupamento!');
                    return;
                }

            }//fim do forEach
        $combQuest = array();
        $combquestaval = null;
        $loop = $combquestpadrRepository->lista_combinacoes_padrao($arrayNrpadravaliacao);
        foreach($loop as $numkey=>$row){
            $combquestaval = \Geral\Util\Novocodigo::geraCodigo(FPA::getNrorgTrabalho(),'COMBQUESTAVAL', 1, 10, true);
            $combQuest[$loop[$numkey]['QTD']] = $combquestaval;
            //Insere na tabela de Combinacao da avaliacao as combinacoes de acordo com o padrao
            $arrayCombquestaval = array('P_COMBQUESTAVAL' => $combquestaval,
                                        'P_NRAVALIACAO'        => $nravaliacao,
                                        'P_QTD'           => $loop[$numkey]['QTD']);
            try{
                $combquestavalRepository->insert_combquestaval($arrayCombquestaval);
             }
            catch(Exception $e) {
                throw tk_message('Nao foi possivel inserir dados na tab de combinação!');
                return;
            }
        }//Fim do forEach
            
            
            
            
            //Retorna os Tipos de Relacionamento do Padrao
            $resultListaRelacPad = $tiporelacpadrRepository->busca_tiporelacpadr($arrayNrpadravaliacao);
            
            foreach ($resultListaRelacPad as $key => $values) {

                $nrTipoRelacPadNovoCod = \Geral\Util\Novocodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'AGRUPQUESTAVAL', 1, 10, true);

                //Insere dados na tabela de Tipo de Relacionamento da Avaliacao (TIPORELACAVAL), de acordo com  a tabela TIPORELACPADR
                //e com a consulta $sqlListaRelacPad
                try {
                    $tiporelacavalEntity = \Geral\Entities\Tiporelacaval::insert($nrtiporelacaval = $nrTipoRelacPadNovoCod,    
                                                                                 $nravaliacao,   
                                                                                 $nrtiporelaciona = $values['NRTIPORELACIONA'],  
                                                                                 $vrpesorelacaval = $values['VRPESORELACPADR'], 
                                                                                 $nrorg = $values['NRORG'],
                                                                                 $idativo = $values['IDATIVO'],
                                                                                 $dtinclusao = DateUtil::getDataAtual(),
                                                                                 $dtultatu = null,
                                                                                 $nrorginclusao = $values['NRORG'], 
                                                                                 $cdoperinclusao = Ambiente::getCdOperador(),
                                                                                 $nrorgultatu = $values['NRORG'],
                                                                                 $cdoperultatu = Ambiente::getCdOperador());
                }
                catch(Exception $e) {
                    throw tk_message('Nao foi possivel inserir dados na tab de tipo de relacionamento!');
                    return;
                }
        }

        $select_questpadraval = array('P_QTD'=> $newPadrao);
        $qtdQuestao = $questpadravalRepository->lista_questpadraval($select_questpadraval);
        for($i = 0; $i<count($qtdQuestao); $i++){
                //Seleciona os campos a inserir na tabela de QUESTAVALIACAO de acordo com a tabela de QUESTPADRAVAL
                $select_insert_padrao_questaval = array('P_QTD' => $newPadrao,
                                                        'P_NRQUESTAO' => $qtdQuestao[$i]['NRQUESTAO']);
                $result = $questpadravalRepository->lista_questpadraval_nrquestao($select_insert_padrao_questaval);

                $nragrupquestava = null;
                if($agrupQuest){
                 if($result[0]['NRAGRUPQUESTPAD'] == ''){
                    $nragrupquestava = null;
                 }else{
                    $nragrupquestava = $agrupQuest[$result[0]['NRAGRUPQUESTPAD']];
                 }
                }

                $nrcombquestaval = null;
                if ($result[0]['NRCOMBQUESTPADR'] == '') {
                    $nrcombquestaval = null;
                } else {
                    // leonardocarvalho - 17/11/2014
                    if ($result[0]['NRCOMBQUESTPADR'] != self::NRCOMB_PADRAO) {
                        if ($combQuest)
                            $nrcombquestaval = $combQuest[$result[0]['NRCOMBQUESTPADR']];
                        else
                            $nrcombquestaval = self::NRCOMB_PADRAO;
                    } else {
                        $nrcombquestaval = $result[0]['NRCOMBQUESTPADR'];
                    }
                }

                $nrorg = empty($result[0]['NRORG'])                               ? FPA::getNrorgTrabalho() : $result[0]['NRORG'];
                $nrnivelquestao = empty($result[0]['NRNIVELQUESTAO'])             ? null : $result[0]['NRNIVELQUESTAO'];
                $vrnotaquestaval = empty($result[0]['VRNOTAQUESTPADR'])           ? FPA::getNrorgTrabalho() : $result[0]['VRNOTAQUESTPADR'];
                $idsortquestaval = empty($result[0]['IDSORTQUESTPADR'])           ? 'SEM_SORTEIO' : $result[0]['IDSORTQUESTPADR'];
                $dsquestavalia = empty($result[0]['DSQUESTPADRAVAL'])             ? null : $result[0]['DSQUESTPADRAVAL']; 
                $nrordequestaval = empty($result[0]['NRORDEQUESTPADR'])           ? null : $result[0]['NRORDEQUESTPADR'];
                $nrorginclusao = empty($result[0]['NRORG'])                       ? null : $result[0]['NRORG'];
                $cdoperinclusao = empty($result[0]['CDOPERINCLUSAO'])             ? null : $result[0]['CDOPERINCLUSAO'];
                $nrorgultatu = empty($result[0]['NRORG'])                         ? null : $result[0]['NRORG'];
                $cdoperultatu = empty($result[0]['CDOPERULTATU'])                 ? null : $result[0]['CDOPERULTATU'];
                $txcomplementoquestao = empty($result[0]['TXCOMPLEMENTOQUESTAO']) ? null : $result[0]['TXCOMPLEMENTOQUESTAO'];
                $nrtemaanalise = empty($result[0]['NRTEMAANALISE'])               ? null : $result[0]['NRTEMAANALISE'];
                $nrquestao = empty($result[0]['NRQUESTAO'])                       ? null : $result[0]['NRQUESTAO'];
//                $nrcombquestaval = $combquestaval;
                
                            Questavaliacao::insert(
                                            $nrquestavalia = \Geral\Util\NovoCodigo::geraCodigo(FPA::getNrorgTrabalho(),'QUESTAVALIACAO', 1, 10, true),
                                            $nrorg,
                                            $nrcombquestaval,
                                            $nrquestao,
                                            $nrnivelquestao,
                                            $vrnotaquestaval,
                                            $idsortquestaval,
                                            $dsquestavalia,
                                            $nrordequestaval,
                                            //valor do array $agrupQuest
                                            $dtinclusao = DateUtil::getDataAtual(),
                                            $dtultatu = DateUtil::getDataAtual(),
                                            $nrorginclusao,
                                            $cdoperinclusao,
                                            $nrorgultatu,
                                            $cdoperultatu,
                                            $nragrupquestava,
                                            $idativo = 'S',
                                            $txcomplementoquestao,
                                            $nrtemaanalise,
                                            $nravaliacao);
        }//Fim do For
        

   return;
   }
  }
  
  public function valida_relacionamento_existente($nravaliacao){
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $array_nravaliacao = array ('P_NRAVAL'=>$nravaliacao);
      $sqlVerificaParticip = $participavalRepository->lista_participante_combquest($array_nravaliacao);
      if ($sqlVerificaParticip) {
          throw new \Exception('Para alterar o padrao, deve-se primeiramente excluir os relacionamentos ligados a essa avaliacao!');
          return false;
      }else{
          return true;
      }
  }
  /*
   * OnChange - NRPADRAVALIACAO (questionario)
   * procura e retorna o questionario antigo gravado antes da troca
   */
  public static function valida_mudanca_questionario($array){
      $avaliacaogeralRepository = \Avaliacao\Entities\Avaliacao::getRepository();
  }

  public static function insereCombinacaoPadrao($nrAvaliacao){
        $combquestavalRepository = \Avaliacao\Entities\Combquestaval::getRepository();
        $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
        $paramsAval = array('P_PADRAO' => 'PADRÃO',
                            'P_NRAVALIACAO' => $nrAvaliacao);
        $nrCombQuest = $combquestavalRepository->lista_combinacaoPadrao($paramsAval);
        $paramsParticipaval = array('P_NRCOMBQUESTAVAL' => $nrCombQuest[0]['NRCOMBQUESTAVAL'],
                                    'P_NRAVALIACAO'     => $nrAvaliacao);
        $participavalRepository->update_participavalCombinacaoPadrao($paramsParticipaval);
        
  }

  /*
   * retorna a faixa por avaliacao
   */
  public function retornaFaixaCriteriosLogic($nravaliacao, $actionName = null){
        // leonardocarvalho - 10/12/2014 - Adicionado parâmetro de NRORG.
        $arrayNravaliacao = array('P_NRAVALIACAO' => $nravaliacao, 'P_NRORG' => FPA::getNrorgTrabalho());
        $tiporesuRepository = \SistemaQualidade\Entities\Tiporesu::getRepository();

        //Retorna as faixas de criterios que pertencem a avaliacao informada
        $resultFaixaCrit = $tiporesuRepository->retornaFaixaCriteriosRepository($arrayNravaliacao);
        return $resultFaixaCrit;
  }
  
  /*
   * retorna a faixa por agrupamento
   */
  public function retornaFaixaCriteriosAgrupamentoLogic($nravaliacao, $nragrupquestava, $actionName, $parcAval = null){
      $arrayNragrupquestava = array('P_NRAGRUPQUESTAVA' => $nragrupquestava, 'P_NRAVALIACAO' => $nravaliacao);
      
      $actionName = str_replace("'", "", $actionName);
      // if((strcmp($actionName, "act_ApuraResultado") || strcmp($actionName, "act_apuraResultadoColaborador") || strcmp($actionName, "act_apuraResultadoTodasAvaliacoes")) == 0){
      if($actionName === "act_ApuraResultado" || $actionName === "act_apuraResultadoColaborador" || $actionName === "act_apuraResultadoTodasAvaliacoes"){
         $tiporesuRepository = \SistemaQualidade\Entities\Tiporesu::getRepository();
         //Retorna as faixas de criterios que pertencem a avaliacao informada
         $resultFaixaCrit = $tiporesuRepository->retornaFaixaCriteriosAgrupamentoRepository($arrayNragrupquestava);
         return $resultFaixaCrit; 
      }
      // if(strcmp($actionName, "act_ApuraResultado2014") || strcmp($actionName, "act_apuraResultadoColaborador2014") || strcmp($actionName, "act_apuraResultadoTodasAvaliacoes2014") == 0){
      if($actionName === "act_ApuraResultado2014"  || $actionName === "act_apuraResultadoColaborador2014" || $actionName === "act_apuraResultadoTodasAvaliacoes2014"){
         $funcionarioRepository = \Geral\Entities\Funcionario::getRepository();
         //retorna o codigo do cargo, codigo da faixa do funcionario de acordo com o nrparcnegocio
         $arrayFuncionario = $funcionarioRepository->retornaCargoFaixaFuncionario($parcAval);
         $params = array('P_NRAGRUPQUESTAVA' => $nragrupquestava, 'P_NRAVALIACAO' => $nravaliacao, 
                         'P_NRFAIXACARGO' => $arrayFuncionario[0]['NRFAIXACARGO'], 'P_CDCARGO' => $arrayFuncionario[0]['CDCARGO']);
         $tiporesuRepository = \SistemaQualidade\Entities\Tiporesu::getRepository();
         //Retorna as faixas de criterios que pertencem a avaliacao informada
         $resultFaixaCrit = $tiporesuRepository->retornaFaixaCriteriosAgrupamento2014Repository($params);
         return $resultFaixaCrit; 
      }
  }
  
  /*
   * retorna a faixa por questao
   */
  public function retornaFaixaQuestaoLogic($nravaliacao, $nrquestavalia){
            $arrayNrquestavalia = array('P_NRAVALIACAO'   => $nravaliacao, 
                                        'P_NRQUESTAVALIA' => $nrquestavalia);
            $tiporesuRepository = \SistemaQualidade\Entities\Tiporesu::getRepository();
            //Retorna as faixas de criterios que pertencem a questao informada
            $resultFaixaCrit = $tiporesuRepository->retornaFaixaCriteriosQuestaoRepository($arrayNrquestavalia);
            return $resultFaixaCrit;
  }
  
  public function retornaColaboradoresAvaliacaoConcluidaLogic($nravaliacao, &$messages){
        $arrayNravaliacao = array('P_NRAVALIACAO' => $nravaliacao);
        $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
        $resultParticipOk = $participavalRepository->retornaColaboradoresAvaliacaoConcluidaRepository($arrayNravaliacao);

        // leonardocarvalho - 10/12/2014 - Valida retorno de $resultParticipOk
        if (!$resultParticipOk) {
            array_push($messages, "Não foram encontrados avaliadores com avaliação concluída ou já foram apurados.");
        }

        return $resultParticipOk;
  }
  
  public function retornaResultadoColaboradoresAptosLogic($arrayParticipantes){
      $respavaliacaoRepository = \Avaliacao\Entities\Respavaliacao::getRepository();
      $resultAux = $respavaliacaoRepository->retornaResultadoColaboradoresAptosRepository($arrayParticipantes);
      return $resultAux;
  }
  
  /*
   * Inicia a apura��o dos resultados para cada participante da avalia��o selecionada , 
   * assim como seus agrupamentos (competencia)
   */
  public function iniciaApuracaoResultadosLogic($resultParticipOk, $nravaliacao, $resultFaixaCrit, &$messages){
        //Inicio contador de resultados apurados
        $totResultApur = 0;

        foreach ($resultParticipOk as $key => $values) {
            $parcAval        = $values['NRPARCAVALIADO'];
            $combQuest       = $values['NRCOMBQUESTAVAL'];
            $nrparcexecaval  = $values['NRPARCEXECAVAL'];
            $nrparticipaval  = $values['NRPARTICIPAVAL'];
            $apurar = new self();
            $totResultApur += $apurar->apurarResultadoColaborador($combQuest, $parcAval, $nrparcexecaval, $nravaliacao, $resultFaixaCrit, $nrparticipaval, $messages);
        }
        
        return $totResultApur;
  }
  
  
   /*
    * Retorna o resultado de somente um colaborador de acordo com o selecionado.
    */
  public function retornaResultadoColaboradorLogic($params, &$messages){
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $result = $participavalRepository->retornaResultadoColaboradorRepository($params);

      // leonardocarvalho - 10/12/2014
      if (!$result) {
          array_push($messages, "Verifique se existe Tipo de Relacionamento por Avaliação.");
      }

      return $result;
  }
  
  public function retornaPkAvaliacoes($dtinirealizaval, $dtfimrealizaval){
      $params = array('P_DTINIREALIZAVAL' => $dtinirealizaval, 
                      'P_DTFIMREALIZAVAL' => $dtfimrealizaval);
      $avaliacaogeralRepository = \Avaliacao\Entities\Avaliacaogeral::getRepository();
      $pksAvaliacoes = $avaliacaogeralRepository->retornaPksAvaliacoes($params);
      return $pksAvaliacoes;
  }
  
  public function desfazApuracaoLogic($nravaliacao){
      $nrorg    = FPA::getNrorgTrabalho();
      $params = array('P_NRAVALIACAO' => $nravaliacao,
                      'P_NRORG'       => $nrorg);
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $colaboradoresApurados = $participavalRepository->retornaColaboradoresApuradosRepository($params);
      foreach ($colaboradoresApurados as $key => $values) {
          $parcAval = $values['NRPARCAVALIADO'];
          $nrComb   = $values['NRCOMBQUESTAVAL'];
           $paramsUpdate = array('P_VRRESULTAVALIA' => null,
                                 'P_CDTIPORESU'     => null,
                                 'P_NRPARCAVALIADO' => $parcAval,
                                 'P_NRCOMBQUESTAVAL'=> $nrComb,
                                 'P_NRAVALIACAO'    => $nravaliacao,
                                 'P_NRORG'          => $nrorg);
           $this->updateDesfazApuracaoLogic($paramsUpdate);
       }
       return count($colaboradoresApurados);
  }
  
  public function excluiApuragrupavalLogic($nravaliacao, $parcAval, $nrorg){
      $agrupamentos = Agrupquestaval::findByNravaliacaoAndNrorg($nravaliacao, $nrorg);
      if(empty($agrupamentos)){
          return;
      }
      $participavalEntity = new \Avaliacao\Entities\Participaval();
      $apuragrupavalRepository = \Avaliacao\Entities\Apuragrupaval::getRepository();
      $arrayParticipaval = $participavalEntity::findByNravaliacaoAndNrparcavaliadoAndNrorg($nravaliacao, $parcAval, $nrorg);
      foreach ($arrayParticipaval as $obj) {
        $nrparticipaval = $obj->getNrparticipaval();
        $params = array('P_NRPARTICIPAVAL' => $nrparticipaval,
                        'P_NRORG'          => $nrorg);
        $apuragrupavalRepository->deleteApuragrupavalRepository($params);
      }
  }
  public function excluiItemApuResultLogic($nravaliacao, $parcAval, $nrorg){
      $participavalEntity = new \Avaliacao\Entities\Participaval();
      $arrayParticipaval = $participavalEntity::findByNravaliacaoAndNrparcavaliadoAndNrorg($nravaliacao, $parcAval, $nrorg);
      foreach ($arrayParticipaval as $obj) {
        $nrparticipaval = $obj->getNrparticipaval();
        $params = array('P_NRPARTICIPAVAL'  => $nrparticipaval,
                        'P_NRORG'          => $nrorg);
        $itemApuResultRepository = \Avaliacao\Entities\ItemApuResult::getRepository();
        $itemApuResultRepository->deletaItemApuResultRepository($params);
      }
  }
  /*
   * updata a tabela participaval e excluir da tabela apuragrupaval
   */
  public function updateDesfazApuracaoLogic($paramsUpdate){
      
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $participavalRepository->updateDesfazApuracao($paramsUpdate);
      $this->excluiApuragrupavalLogic($paramsUpdate['P_NRAVALIACAO'], $paramsUpdate['P_NRPARCAVALIADO'], $paramsUpdate['P_NRORG']);
      $this->excluiItemApuResultLogic($paramsUpdate['P_NRAVALIACAO'], $paramsUpdate['P_NRPARCAVALIADO'], $paramsUpdate['P_NRORG']);
  }
  /*
   * Desfaz a apuracao para todas as avaliacoes do periodo 
   */
  public function desfazApuracaoTodasAvaliacoesLogic($arrayPkAvaliacoes){
      $totResultApur = '';
      
      for($i=0; $i < count($arrayPkAvaliacoes); $i++){
            //Desfaz Apuracao da avaliacao
            $totResultApur += $this->desfazApuracaoLogic($arrayPkAvaliacoes[$i]['NRAVALIACAO']);
      }
      
      return $totResultApur;
  }
  
  public function verificaExecavaliacaoLogic($nravaliacao, $nrparcavaliado, $nrparcexecaval){
      $participante = Execavaliacao::findOneByNravaliacaoAndNrparcavaliadoAndNrparcexecaval($nravaliacao, $nrparcavaliado, $nrparcexecaval);
      return $participante;
  }
  
  /*
   * Apura resultado de todas as avaliacoes do grid assim como suas competencias
   */
  public function apuraResultadoTodasAvaliacoesLogic($arrayPkAvaliacoes, $actionName){
      $totResultApur = '0';
      for ($i=0; $i < count($arrayPkAvaliacoes); $i++) {

            try {
                $resultFaixaCrit = $this->retornaFaixaCriteriosLogic($arrayPkAvaliacoes[$i]['NRAVALIACAO']);
                if(empty($resultFaixaCrit)){
                    continue;
                }
            } catch (\Exception $e) {
               return $e->getMessage();
            }

            try {
                //retorna somente se todas as avalia��es foram conclu�das
                $resultParticipOk = $this->retornaColaboradoresAvaliacaoConcluidaLogic($arrayPkAvaliacoes[$i]['NRAVALIACAO']);
            } catch (\Exception $e) {
                return $e->getMessage();
            }

            //Inicia Apuração por avaliacao
            $totResultApur += $this->iniciaApuracaoResultadosLogic($resultParticipOk, $arrayPkAvaliacoes[$i]['NRAVALIACAO'], $resultFaixaCrit, $actionName);
      }  
      return $totResultApur;
  }
  
  /*
   * Apura o resultado do colaborador passado no parametro
   */
public function apurarResultadoColaborador($combQuest, $parcAval, $nrparcexecaval, $nravaliacao, $resultFaixaCrit, $nrparticipaval, &$messages){
      $params = array('P_NRAVALIACAO'    => $nravaliacao,
                     'P_NRCOMBQUESTAVAL' => $combQuest,
                     'P_NRPARCEXECAVAL'  => $nrparcexecaval,
                     'P_NRPARCAVALIADO'  => $parcAval,
                     'P_NRORG'           => FPA::getNrorgTrabalho());
      $entity = \Avaliacao\Entities\Participaval::getRepository();

//    @todo trecho utilizado somente para o avaliação 2014
//      $resultFaixaCritTemp = '';

//      if (strcmp($actionName, "act_ApuraResultado2014") || strcmp($actionName, "act_apuraResultadoColaborador2014") || strcmp($actionName, "act_apuraResultadoTodasAvaliacoes2014") == 0) {
//         //retorna o codigo do cargo, codigo da faixa do funcionario de acordo com o nrparcnegocio
//         $funcionarioRepository = \Geral\Entities\Funcionario::getRepository();
//         $arrayFuncionario = $funcionarioRepository->retornaCargoFaixaFuncionario($parcAval);
//
//         if (!empty($arrayFuncionario[0]['NRFAIXACARGO'])) {
//             $paramsCritAvaliacao = array('P_NRAVALIACAO' => $nravaliacao,
//                                          'P_NRFAIXACARGO' => $arrayFuncionario[0]['NRFAIXACARGO'],
//                                          'P_CDCARGO' => $arrayFuncionario[0]['CDCARGO']);
//             $tiporesuRepository = \SistemaQualidade\Entities\Tiporesu::getRepository();
//             $resultFaixaCritTemp = $tiporesuRepository->retornaFaixaCriterios2014Repository($paramsCritAvaliacao);
//         } else {
//             $this->funcionariosSemFaixa .= '<BR>'.$arrayFuncionario[0]['NMFUNC'];
//         }
//
//      }
      
//      if (empty($resultFaixaCritTemp[0])) {
//          $resultFaixaCritTemp = $resultFaixaCrit;
//      }

      //Retorna o resultado bruto (sem média com o líder) de somente um colaborador de acordo com o parametro.
      $resultBruto = $this->retornaResultadoColaboradorLogic($params, $messages);
      
      $apurar = new self();
      $totResultApur = $this->salvaResultado($resultFaixaCrit, $resultBruto[0]['RESULTADO'], $combQuest,
                           $parcAval, $nrparcexecaval, $nravaliacao, $entity, null, $nrparticipaval, $messages);

      //apura o resultado dos agrupamentos da avaliacao, caso existam
      $apurar->apuraResultadoAgrupamento($combQuest, $parcAval, $nrparcexecaval, $nravaliacao, $resultFaixaCrit, $nrparticipaval, $messages);
//
      return $totResultApur;
  }
  
  /*
   * Apura o resultado de acordo com o agrupamento (competencia)
   */
  public function apuraResultadoAgrupamento($combQuest, $parcAval, $nrparcexecaval, $nravaliacao, $resultFaixaCritAvaliacao, $nrparticipaval, &$messages){
      $agrupamentos = Agrupquestaval::findByNravaliacao($nravaliacao);

      if(empty($agrupamentos)){
          array_push($messages, "Avaliação '$nravaliacao' não possui agrupamento.");
      }
      
      for ($index = 0; $index < count($agrupamentos); $index++) {
        $nragrupquestava = $agrupamentos[$index]->getNragrupquestava();

        $params = array('P_NRAVALIACAO'     => $nravaliacao,
                        'P_NRCOMBQUESTAVAL' => $combQuest,
                        'P_NRPARCAVALIADO'  => $parcAval,
                        'P_NRPARCEXECAVAL'  => $nrparcexecaval,
                        'P_NRAGRUPQUESTAVA' => $nragrupquestava,
                        'P_NRORG' => FPA::getNrorgTrabalho());

        $entity = \Avaliacao\Entities\Apuragrupaval::getRepository();

        // retorna média bruta do colaborador
        // verifica se existe mais de um relacionamento com pesos diferentes
        $paramRelacionamento = $this->relacionamentosPesoDiferente($nravaliacao, FPA::getNrorgTrabalho());
        $resultado = $entity->retornaResultadoColaboradorAgrupamentoRepository($params, $paramRelacionamento);

        if (empty($resultado[0]['RESULTADO'])) {
            continue;
        }

        //$resultFaixaCritAgrupamento = $this->retornaFaixaCriteriosAgrupamentoLogic($nravaliacao, $nragrupquestava, $actionName, $parcAval);

        //caso nao exista criterio de avaliacao para o agrupamento, utilizara como padrao o criterio da avaliacao
        //if (empty($resultFaixaCritAgrupamento)) {
            $resultFaixaCritAgrupamento =  $resultFaixaCritAvaliacao;
        //}
        
        $this->salvaResultado($resultFaixaCritAgrupamento, $resultado[0]['RESULTADO'], $combQuest, $parcAval, $nrparcexecaval, $nravaliacao, $entity, $nragrupquestava, $nrparticipaval, $messages);
      }
      return;
  }
  
  //Verifica a faixa em que o resultado se encontra e grava o resultado
  public function salvaResultado($resultFaixaCrit, $resultado, $combQuest, $parcAval, $nrparcexecaval, $nravaliacao,
                                $entity, $nragrupquestava = null, $nrparticipaval = null, &$messages){

        $totResultApur = 0;
        $objAvaliacaoGeral = \Avaliacao\Entities\Avaliacaogeral::findOneByNravaliacao($nravaliacao);
        $nmavaliacao = $objAvaliacaoGeral->getNmavaliacao();
        $result 	    = str_replace(',', '.', $resultado."");

        //verifica se estou trabalhando com insercao em Participaval
        if ($entity->getClassName() == "Avaliacao\Entities\Participaval") {

            $cdTipoResu = $this->retornaFaixaCdtiporesu($resultFaixaCrit, $resultado);
            $participaval = \Avaliacao\Entities\Participaval::getRepository();
//
            $params = array('P_NRPARCAVALIADO' => $parcAval, 'P_NRAVALIACAO' => $nravaliacao, 'P_NRORG' => FPA::getNrorgTrabalho(), 'P_NRPARCEXECAVAL' => $nrparcexecaval);

            // so permite apuracao se houver relacionamento por avaliação
//            $nrparticipavalMaiorRelac = $participaval->retornaNrparticipavalMaiorRelacionamento($params);
            $nrparticipavalRelac = $participaval->retornaNrparticipavalRelacionamentos($params);

            if (empty($nrparticipavalRelac[0])) {
                array_push($messages, "Avaliado '$parcAval' não participa da avaliação '$nravaliacao'.");
            }

//            $objParticipaval = \Avaliacao\Entities\Participaval::findByNravaliacaoAndNrparcavaliadoAndNrparcexecaval($nravaliacao, $parcAval, $nrparcexecaval);

            $paramsUpdate = array('P_VRRESULTAVALIA'  => round($result, 2),
                'P_CDTIPORESU'      => $cdTipoResu,
                'P_NRAVALIACAO'     => $nravaliacao,
                'P_NRCOMBQUESTAVAL' => $combQuest,
                'P_NRPARCAVALIADO'  => $parcAval,
                'P_NRPARCEXECAVAL'  => $nrparcexecaval,
                'P_IDSITUACAOAVAL'  => 'CONCLUIDA');

            $avaliacaoItemApuResult = $this->retornaAvaliacaoItem_apu_result($nmavaliacao, $nrparticipaval);
            
            
            //se ja nao houver o resultado na apuResult, insere
            if (empty($avaliacaoItemApuResult)) {

//                if ($objParticipaval[0]->getNrparticipaval() == $nrparticipaval['NRPARTICIPAVAL']) {

                $paramsResultadoPonderadoAvaliacao = array('P_NRAVALIACAO'     => $nravaliacao,
                                                           'P_NRCOMBQUESTAVAL' => $combQuest,
                                                           'P_NRPARCAVALIADO'  => $parcAval,
                                                           'P_NRORG'           => FPA::getNrorgTrabalho());

                $resultadoPonderado = $entity->resultadoPonderadoAvaliacaoRepository($paramsResultadoPonderadoAvaliacao);
                $cdTipoResuApu = $this->retornaFaixaCdtiporesu($resultFaixaCrit, round($resultadoPonderado[0]['RESULTADO'], 2));
                $nritemapuraresult = \Geral\Util\NovoCodigo::geraCodigo(FPA::getNrorgTrabalho(), 'ITEM_APU_RESULT', 1, 22, FALSE, TRUE);

                $paramsItemApuResult = array('P_VRRESULTITEMAP'  => round($resultadoPonderado[0]['RESULTADO'], 2),
                                             'P_NRITEMAPURESULT' => $nritemapuraresult,
                                             'P_CDTIPORESU'      => $cdTipoResuApu,
                                             'P_DSITEMAPURESULT' => $nmavaliacao,
                                             'P_NRITEMORIGEM'    => $nravaliacao,
                                             'P_IDITEMAPURESULT' => '1',
                                             'P_NRORG'           => FPA::getNrorgTrabalho(),
                                             'P_NRCRITERIORESUL' => $resultFaixaCrit[0]['NRCRITERIORESUL'],
                                             'P_NRPARTICIPAVAL'  => $nrparticipaval);

                $objItemApuResult = \Avaliacao\Entities\ItemApuResult::getRepository();
                $objItemApuResult->insertAvaliacaoItemApuResult($paramsItemApuResult);
                
                // update participaval com o valor calculado
                $entity->updateResultadoApurado($paramsUpdate);

                $totResultApur++;

//                }

            }

        }

        // verifica se estou trabalhando com insercao em Apuragrupaval
        if ($entity->getClassName() == "Avaliacao\Entities\Apuragrupaval") {
            $apuragrupavalRepository =  \Avaliacao\Entities\Apuragrupaval::getRepository();
            $participaval = \Avaliacao\Entities\Participaval::getRepository();

            $paramsAgrupamentosApurados = array('P_NRAGRUPQUESTAVA' => $nragrupquestava,
                                                'P_NRPARCAVALIADO'  => $parcAval,
                                                'P_NRPARCEXECAVAL'  => $nrparcexecaval,
                                                'P_NRAVALIACAO'     => $nravaliacao,
                                                'P_NRORG'           => FPA::getNrorgTrabalho());

            $apuragrupavalApurados = $apuragrupavalRepository->retornaAgrupamentosApurados($paramsAgrupamentosApurados);

            /* nao deixa apurar para avaliado sem lider avaliando o mesmo já que o peso da avaliacao do lider e o maior */
            $params = array('P_NRPARCAVALIADO' => $parcAval, 'P_NRAVALIACAO' => $nravaliacao, 'P_NRORG' => FPA::getNrorgTrabalho(), 'P_NRPARCEXECAVAL' => $nrparcexecaval);

//            $nrparticipavalMaiorRelac = $participaval->retornaNrparticipavalMaiorRelacionamento($params);
            $nrparticipavalRelac = $participaval->retornaNrparticipavalRelacionamentos($params);

            if (empty($nrparticipavalRelac[0])) {
                array_push($messages,"Avaliado '$parcAval' não participa da avaliação '$nravaliacao'.");
            }

            $avaliacaoItemApuResult = $this->retornaAvaliacaoItem_apu_result($nmavaliacao, $nrparticipaval);

            if (!empty($avaliacaoItemApuResult)) {
                $objAgrupquestaval = \Avaliacao\Entities\Agrupquestaval::findByNravaliacaoAndNragrupquestava($nravaliacao, $nragrupquestava);
                $objAgrupamentoItemApuResult = $this->retornaAgrupamentoItem_apu_result($avaliacaoItemApuResult[0]->getNritemapuresult(), $nrparticipaval, $objAgrupquestaval[0]->getNmagrupquestava());

                if (empty($objAgrupamentoItemApuResult[0])) {
                    $paramsResultadoAgrupamentoPonderado = array('P_NRAGRUPQUESTAVA' => $nragrupquestava,
                                                                 'P_NRPARCAVALIADO'  => $parcAval,
                                                                 'P_NRCOMBQUESTAVAL' => $combQuest,
                                                                 'P_NRAVALIACAO'     => $nravaliacao);

                    // verifica se existe mais de um relacionamento com pesos diferentes
                    $paramRelacionamento = $this->relacionamentosPesoDiferente($nravaliacao, FPA::getNrorgTrabalho());
                    $resultadoPonderadoAgrupamento = $apuragrupavalRepository->retornaResultadoPonderadoAgrupamentoRepository($paramsResultadoAgrupamentoPonderado, $paramRelacionamento);

                    if (!empty($resultadoPonderadoAgrupamento[0]['RESULTADO'])) {
                        $cdTipoResu = $this->retornaFaixaCdtiporesu($resultFaixaCrit, $resultadoPonderadoAgrupamento[0]['RESULTADO']);
                        $nritemapuraresult = \Geral\Util\NovoCodigo::geraCodigo(FPA::getNrorgTrabalho(),  'ITEM_APU_RESULT', 1, 22);

                        $paramsAgrupamentoItemApuResult = array('P_VRRESULTITEMAP'  => round($resultadoPonderadoAgrupamento[0]['RESULTADO'], 2),
                                                                'P_NRITEMAPURESULT' => $nritemapuraresult,
                                                                'P_CDTIPORESU'      => $cdTipoResu,
                                                                'P_DSITEMAPURESULT' => $objAgrupquestaval[0]->getNmagrupquestava(),
                                                                'P_NRITAPUNIVELANT' => $avaliacaoItemApuResult[0]->getNritemapuresult(),
                                                                'P_NRITEMORIGEM'    => $nragrupquestava,
                                                                'P_IDITEMAPURESULT' => '2',
                                                                'P_NRORG'           => FPA::getNrorgTrabalho(),
                                                                'P_NRCRITERIORESUL' => $resultFaixaCrit[0]['NRCRITERIORESUL'],
                                                                'P_NRPARTICIPAVAL'  => $nrparticipaval);

                        $itemApuResultRepository = \Avaliacao\Entities\ItemApuResult::getRepository();
                        $itemApuResultRepository->insereAgrupamentoItemApuResult($paramsAgrupamentoItemApuResult);
                        $this->insereQuestaoItemApuResultLogic($nravaliacao, $parcAval, $combQuest, $nragrupquestava, $nritemapuraresult, $nrparticipaval, $resultFaixaCrit);
                    }

                }

            }

            //verifica se será um insert seguido de update ou se será somente um update
            $cdTipoResu = $this->retornaFaixaCdtiporesu($resultFaixaCrit, $result);

            if (empty($apuragrupavalApurados)) {
                try {
                    //somente insert
                    $objParticipaval = \Avaliacao\Entities\Participaval::findByNravaliacaoAndNrparcavaliadoAndNrparcexecavalAndNrorg($nravaliacao, $parcAval, $nrparcexecaval, FPA::getNrorgTrabalho());
                    $apuragrupavalEntity = new \Avaliacao\Entities\Apuragrupaval();
                    $apuragrupavalEntity->insertChavesApuragrupaval($nragrupquestava, $objParticipaval[0]->getNrparticipaval(), $cdTipoResu);
                    $apuragrupavalEntity->updateResultadoApuragrupaval(round($result, 2), $cdTipoResu);
                } catch (\Exception $e) {
                    return $e->getMessage();
                }
            } else {
                  //somente update
                try {
                    for ($index = 0; $index < count($apuragrupavalApurados); $index++) {
                        $objApuragrupaval = \Avaliacao\Entities\Apuragrupaval::findOneByNrparticipavalAndNragrupquestavaAndNrorg($apuragrupavalApurados[$index]['NRPARTICIPAVAL'], $apuragrupavalApurados[$index]['NRAGRUPQUESTAVA'], FPA::getNrorgTrabalho());
                        $objApuragrupaval->updateResultadoApuragrupaval(round($result, 2), $cdTipoResu);
                    }
                } catch (\Exception $e) {
                    return $e->getMessage();
                }
            }

        }

        return $totResultApur;
  }
  
  public function retornaAvaliacaoItem_apu_result($nmavaliacao, $nrparticipaval){
      //valida se existe um participaval de maior relacionamento ja com media ponderada para a avaliacao
      $itemApuResult = \Avaliacao\Entities\ItemApuResult::findByNrparticipavalAndDsitemapuresultAndNrorg($nrparticipaval, $nmavaliacao, FPA::getNrorgTrabalho());
      return $itemApuResult;
  }
  
  public function retornaAgrupamentoItem_apu_result($nritemapuresult, $nrparticipaval, $nmagrupquestava){
      //valida se existe um agrupquestaval de maior relacionamento ja com media ponderada para o agrupamento
      $itemApuResult = \Avaliacao\Entities\ItemApuResult::findByNrparticipavalAndDsitemapuresultAndNritapunivelant($nrparticipaval, $nmagrupquestava, $nritemapuresult);
      return $itemApuResult;
  }

  public function retornaQuestaoItem_apu_result($nritemapuresult, $nrparticipaval, $txquestao){
      //valida se existe uma questao de maior relacionamento ja com media ponderada para o agrupamento
      $itemApuResult = \Avaliacao\Entities\ItemApuResult::findByNrparticipavalAndDsitemapuresultAndNritapunivelant($nrparticipaval, $txquestao, $nritemapuresult);
      return $itemApuResult;
  }
  
  
  public function insereQuestaoItemApuResultLogic($nravaliacao, $parcAval, $combQuest, $nragrupquestava, $nritemapuraresult,
                                                  $nrparticipaval, $resultFaixaCrit){
    
    //resultado ponderado das questoes do agrupamento
    $paramsQuestaoItemApuResult = array('P_NRAVALIACAO'     => $nravaliacao, 
                                        'P_NRPARCAVALIADO'  => $parcAval, 
                                        'P_NRCOMBQUESTAVAL' => $combQuest, 
                                        'P_NRCOMBQUESTAVAL' => $combQuest, 
                                        'P_NRAGRUPQUESTAVA' => $nragrupquestava);

    $questaoRepository = \Avaliacao\Entities\Questao::getRepository();

    // verifica se existe mais de um relacionamento com pesos diferentes
    $paramRelacionamento = $this->relacionamentosPesoDiferente($nravaliacao, FPA::getNrorgTrabalho());
    $arrayQuestoes = $questaoRepository->retornaQuestoesAgrupamentoItemApuResult($paramsQuestaoItemApuResult, $paramRelacionamento);

    for ($index = 0; $index < count($arrayQuestoes); $index++) {
        $nrquestao = $arrayQuestoes[$index]['NRQUESTAO'];
        $txquestao = $arrayQuestoes[$index]['TXQUESTAO'];
        $nrquestavalia = $arrayQuestoes[$index]['NRQUESTAVALIA'];
        $objAgrupamentoItemApuResult = $this->retornaQuestaoItem_apu_result($nritemapuraresult, $nrparticipaval, $txquestao);

        if (empty($objAgrupamentoItemApuResult[0])) {
            $questaoItemApuResultRepository = \Avaliacao\Entities\ItemApuResult::getRepository();
            $paramsQuestaoApura = array('P_NRPARCAVALIADO' => $parcAval, 
                                        'P_NRAGRUPQUESTAVA'=> $nragrupquestava, 
                                        'P_NRCOMBQUESTAVAL'=> $combQuest, 
                                        'P_NRAVALIACAO'    => $nravaliacao, 
                                        'P_NRQUESTAO'      => $nrquestao);

            $resultadoPonderadoQuestao = $questaoRepository->retornaResultadoPonderadoQuestaoRepository($paramsQuestaoApura, $paramRelacionamento);
            $resultFaixaCritQuestao = $this->retornaFaixaQuestaoLogic($nravaliacao, $nrquestavalia);

            if (empty($resultFaixaCritQuestao)) {
                $resultFaixaCritQuestao = $resultFaixaCrit;
            }

            $cdTipoResuQuestao = $this->retornaFaixaCdtiporesu($resultFaixaCritQuestao, $resultadoPonderadoQuestao[0]['RESULTADO']);
            $nritemapuraresultQuestao = \Geral\Util\NovoCodigo::geraCodigo(FPA::getNrorgTrabalho(), 'ITEM_APU_RESULT', 1, 22);

            $paramsAgrupamentoItemApuResult = array('P_VRRESULTITEMAP'  => round($resultadoPonderadoQuestao[0]['RESULTADO'], 2),
                                                    'P_NRITEMAPURESULT' => $nritemapuraresultQuestao,
                                                    'P_DSITEMAPURESULT' => $txquestao,
                                                    //nritemapuresult do agrupamento
                                                    'P_NRITAPUNIVELANT' => $nritemapuraresult,
                                                    'P_IDITEMAPURESULT' => '3',
                                                    'P_NRITEMORIGEM'    => $nrquestao,
                                                    'P_NRORG'           => FPA::getNrorgTrabalho(),
                                                    'P_CDTIPORESU'      => $cdTipoResuQuestao,
                                                    'P_NRCRITERIORESUL'  => $resultFaixaCritQuestao[0]['NRCRITERIORESUL'],
                                                    'P_NRPARTICIPAVAL'  => $nrparticipaval);
            $questaoItemApuResultRepository->insereQuestaoItemApuResultRepository($paramsAgrupamentoItemApuResult);
        }
    }
  }
  
  
  
  public function retornaFaixaCdtiporesu($resultFaixaCrit, $resultado){
      for ($k = 0; $k < count($resultFaixaCrit); $k++) {
        //id da faixa de criterio, vr inicial, vr final e codigo do tipo de resultado retornados da consulta $sqlFaixaCrit
        $idFaixaCrit       = $resultFaixaCrit[$k]['IDFAIXACRIRESUL'];
        $vrIniFaixaCritAux = $resultFaixaCrit[$k]['VRINIFAIXARESUL'];
        $vrFinFaixaCritAux = $resultFaixaCrit[$k]['VRFINFAIXARESUL'];
        $cdTipoResu        = $resultFaixaCrit[$k]['CDTIPORESU'];

        $result 	= str_replace(',', '.', $resultado);
        $vrIniFaixaCrit = str_replace(',', '.', $vrIniFaixaCritAux);
        $vrFinFaixaCrit = str_replace(',', '.', $vrFinFaixaCritAux);
        
        //Se resultado final estiver entre vr inicial e vr final da faixa de criterio
        if ($idFaixaCrit === 'ENTRE'){
            
            if (($result >= $vrIniFaixaCrit) && ($result <= $vrFinFaixaCrit)) {
                return $cdTipoResu;
            }
            
        }
        
        //Se resultado final for maior que vr inicial e vr final da faixa de criterio
        else if ($idFaixaCrit === 'MAIOR_QUE') {
            
            if ($result >= $vrIniFaixaCrit) {
                return $cdTipoResu;
            }
            
        }
        
        //Se resultado final for maior que vr inicial e vr final da faixa de criterio
        else if ($idFaixaCrit === 'MENOR_QUE') {
            
            if (intval($result) < intval($vrIniFaixaCrit)) {
                return $cdTipoResu;
            }
            
        }
        
        //se o resultado for igual ao valor inicial da faixa
        else if ($idFaixaCrit === 'IGUAL') {
            
            if ($result == $vrIniFaixaCrit) {
                return $cdTipoResu;
            }
            
        }
        
      }
  }
  
  public function validaLideranca($params){
      
      	//Verifica se o parceiro logado � l�der
        $participaval = \Avaliacao\Entities\Participaval::getRepository();
        $bool = $participaval->retornaSeLider($params);
        
        return $bool;
  }
  
  public function retornaOperadorLogado($cdoperador){
      
        $operador = \Geral\Entities\Operador::findOneByCdoperador($cdoperador);
        
        return $operador;
  }
  
  public function retornaNrparcnegocio($cdoperador){
      
      $objOperador = \Geral\Entities\Operador::findOneByCdoperador($cdoperador);
      $nrparcnegocio = $objOperador->getNrparcnegocio();
            
         return $nrparcnegocio;
  }

  public function retornaExecavaliacoes($sqlAvaliacoes) {
      $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sqlAvaliacoes, array());
      return $result;
  }
  
  //notifica planos de a��o dos lideres pendentes por avaliacao
  public function notificaPendentesAvaliacaoLogic($nravaliacao){
      
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      
      $objAvaliacaoGeral = Avaliacaogeral::findOneByNravaliacao($nravaliacao);
      
      $nmavaliacao = $objAvaliacaoGeral->getNmavaliacao();
      
      $params = array('P_NRAVALIACAO' => $nravaliacao);
      
      $arrayLideresEmails = $participavalRepository->notificaPendentesAvaliacaoRepository($params);

      $cdoperador = \Geral\Util\Ambiente::getCdOperador();
      $operador = self::retornaOperadorLogado($cdoperador);

      /* @var $operador \Geral\Entities\Operador */
      $emailOperadorLogado = $operador->getDsemailoper();
      $nomeOperadorLogado = $operador->getNmoperador();
      
      
      
        $ip = "192.168.122.10";
        $auth = 'login';
        $username = 'daniela.farias@teknisa.com';
        $password = 'Berepe1213';
      
      $tr = $this->retornaZendMailTranspSmtp($ip, $auth, $username, $password);
      
      \Zend_Mail::setDefaultTransport($tr);
      $qtdLideres = count($arrayLideresEmails);
      $qtdLiderados = 0;
      $cont = 0;
      $contFail = 0;
      
      $colabSemEmail = array();
      
      foreach ($arrayLideresEmails as $key => $LideresEmail) {
          
          $nrparcexecaval  = $LideresEmail['NRPARCEXECAVAL'];
          $nmprincipalparc = $LideresEmail['NMPRINCIPALPARC'];
          $email           = $LideresEmail['DSEMAILOPER'];
          $liderados       = '';
          
          $params = array('P_NRAVALIACAO' => $nravaliacao, 'P_NRPARCEXECAVAL' => $nrparcexecaval);
          
          $acoesPendentes = $participavalRepository->retornaAcoesPendentes($params);
          
          $qtdLiderados = $qtdLiderados + count($acoesPendentes);
          $tamanho = 0;
          
          foreach ($acoesPendentes as $liderado){
              
              $aux = strlen($liderado['NMPRINCIPALPARC']);
              if($tamanho < $aux){
                  
                  $tamanho = $aux;
              }
          }
          
          $avaliacao = utf8_decode("Avaliação: $nmavaliacao");
          $aux = strlen($avaliacao);
          
          if($tamanho < $aux){
              
            $tamanho = $aux;
          }
          
          $hifen = '-';
          
          foreach ($acoesPendentes as $liderado){
              
              $str = $liderado['NMPRINCIPALPARC'];
              $str = str_pad($str, $tamanho+1, $hifen, STR_PAD_RIGHT);
              $liderados = $liderados. " \n" .$str;
          }
          
          $desenho = '';
          $desenho = str_pad($desenho, $tamanho+1, $hifen, STR_PAD_RIGHT);
          $avaliacao = str_pad(utf8_decode($avaliacao), $tamanho+1, $hifen, STR_PAD_RIGHT);
          $avaliacao = utf8_encode($avaliacao);
          $str_equipe = 
          "Necessita elaborar ações para:\n\n".
          "$desenho\n".
          "$avaliacao\n".
          "$liderados\n".
          "$desenho\n";

          $assunto  = "Avaliação Desempenho - Plano de Ação: $nmavaliacao";
          
         $corpo_msg          = "Prezado(a) ".utf8_encode($nmprincipalparc).", \n\nNo sistema de Avaliação de Desempenho, quanto à elaboração do plano de ação, constam pendências em seu nome.\n\n".
                $str_equipe."Atenciosamente,\n\n$nomeOperadorLogado.";
         //$corpo_msg          = "Prezado(a) $nmprincipalparc, \n\nNo sistema de Avalia��o de Desempenho, quanto � elabora��o do plano de a��o, constam pend�ncias em seu nome.\n\n".
         //       "Suas pend�ncias:\n\n".
         //                     $str_equipe."\n\nInformamos ainda que foi disponibilizado um menu AJUDA contendo um tutorial PASSO A PASSO e um canal de comunica��o chamado D�VIDAS E SUGEST�ES.\n\n".
         //                    "HOJE � O �LTIMO DIA PARA A CONCLUS�O DO PLANO DE A��O, REGULARIZE-SE\n\nAtenciosamente,\n$nome_remetente.";
         // $corpo_msg          = "Prezado(a) $nmprincipalparc, \n\n O prazo para a conclusão do plano de ação já se encerrou, porém, em CAR�?TER DE EXCEÇÃO foi concedido um novo prazo até dia 01/02/2012.\n".
         //                   "No sistema de Avaliação de Desempenho, quanto é elaboração do plano de ação, constam pendências em seu nome.\n\n".
         //"Suas pendências:\n\n".
         //                     $str_equipe."\n\nInformamos ainda que foi disponibilizado um menu AJUDA contendo um tutorial PASSO A PASSO e um canal de comunicação chamado DÚVIDAS E SUGESTÕES.\n\n".
           //                   "Atenciosamente,\n$nome_remetente.";
        $nome_destinatario  = $nmprincipalparc;
        
        if ($email === null) {
      
            $nmOperExplode      = explode(' ', $nmprincipalparc);
            $primeiroNmOperador = strtolower(array_shift($nmOperExplode));
            $ultimoNmOperador  = strtolower(array_pop($nmOperExplode));
            $email_destinatario = "$primeiroNmOperador.$ultimoNmOperador@teknisa.com";  
            $email_destinatario = strtr(utf8_decode($email_destinatario), utf8_decode("��������������"), "aaaaeeiooouucn");
            $email_destinatario = utf8_encode($email_destinatario);
        }
        
        else {
            
         $email_destinatario = $email;
        }
        
        
        if (($email_destinatario === null) || ($email_destinatario === false)) {
            
             $colabSemEmail[$key] = $nmprincipalparc;
        }
          
        try {
            
            $arrayDestinatario = array($emailOperadorLogado);
            $arrayCc           = array($emailOperadorLogado); 
            
            $this->enviaZendMail($emailOperadorLogado, $nomeOperadorLogado,  //De/From
                                 $corpo_msg,                                 //texto
                                 $arrayDestinatario,   $nome_destinatario,   //Destinat�rio/To
                                 $arrayCc,             $nomeOperadorLogado,  //Copia/Cc
                                 $assunto);
            
            $cont++;
       }catch (Exception $e) {
           
            $contFail++;
       }
     }
     
     $arrayMensagens = array('QTDLIDERES'  => $qtdLideres, 'QTDLIDERADOS' => $qtdLiderados,
                             'QTDENVIADOS' => $cont,           'QTDERROS' => $contFail,
                             'ARRAY'       => $colabSemEmail);
     
     return $arrayMensagens;
   }
   
   public function enviaZendMail($emailFrom, 
                                 $nomeFrom,
                                 $corpo_msg, 
                                 $arrayEmailTo, 
                                 $nomeTo,
                                 $arrayEmailCc,
                                 $nomeCc,
                                 $assunto){
           
            $mail = new \Zend_Mail();
            $mail->setFrom($emailFrom, utf8_decode($nomeFrom));
            //$mail->setFrom('daniela.farias@teknisa.com', utf8_decode($nome_remetente));
            $mail->setBodyText(utf8_decode($corpo_msg), null, 'UTF-8');
            //$mail->addTo($arrayEmailTo, utf8_decode($nomeTo));
            $mail->addTo('thiago.pereira@teknisa.com', utf8_decode($nomeTo));
            //$mail->addCc($arrayEmailCc, utf8_decode($nomeOperadorLogado));
            $mail->addCc('thiago.pereira@teknisa.com', utf8_decode($nomeCc));
            $mail->setSubject(utf8_decode($assunto));
       try {
           
            $mail->send();
       } catch (Exception $exc) {
           
           $exc->getMessage();
           tk_warning("excpt");
       }

        
       
   }
   
   public function retornaZendMailTranspSmtp($ip, $auth, $username, $password){
       
       $tr = new \Zend_Mail_Transport_Smtp (
               
        $ip,
        array(
                'auth'     => $auth,
                'username' => $username,
                'password' => $password,
        )
      );
       
      return $tr;
   }
   
   
   public function notificaExpiradosAvaliacaoLogic($nravaliacao, $operador){
       
      $participavalRepository = \Avaliacao\Entities\Participaval::getRepository();
      $params = array('P_NRAVALIACAO' => $nravaliacao);
      $arrayLideresEmails = $participavalRepository->notificaExpiradosAvaliacaoRepository($params);
      $emailOperadorLogado = $operador->getDsemailoper();
      $nomeOperadorLogado = $operador->getNmoperador();
      
      $tr = new \Zend_Mail_Transport_Smtp (
        "192.168.122.10",
//        array(
//            'auth'     => 'login',
//            'username' => 'thiago.pereira@teknisa.com',
//            'password' => 'Vrum2040',
//        )
              
        array(
          'auth'     => 'login',
          'username' => 'daniela.farias@teknisa.com',
          'password' => 'Berepe1213',
        )
      );
      
      \Zend_Mail::setDefaultTransport($tr);
      
      $qtdLideres = count($arrayLideresEmails);
      $qtdLiderados = 0;
      $cont = 0;
      $contFail = 0;
      
      $colabSemEmail = array();
      
      foreach ($arrayLideresEmails as $key => $LideresEmail) {
          
          $nrparcexecaval  = $LideresEmail['NRPARCEXECAVAL'];
          $nmprincipalparc = $LideresEmail['NMPRINCIPALPARC'];
          $email           = $LideresEmail['DSEMAILOPER'];
          $liderados       = '';
          
          $params = array('P_NRAVALIACAO' => $nravaliacao, 'P_NRPARCEXECAVAL' => $nrparcexecaval);
          
          $acoesExpiradas = $participavalRepository->retornaAcoesExpiradas($params);
          
          $qtdLiderados = $qtdLiderados + count($acoesExpiradas);
          
          foreach ($acoesExpiradas as $liderado){
              
              $liderados = $liderados. ' \n' .$liderado['NMPRINCIPALPARC'];
          }
          
          $str_equipe = "Necessita verificar data de conclus�o de a��es para:\n\n".
                          "$liderados";

          $nome_remetente    = 'Daniela Farias';
          //$email_remetente   = 'daniela.farias@teknisa.com';
          $email_remetente   = 'daniela.farias@teknisa.com';
          $assunto           = 'Avaliação Desempenho: ações com prazo expirado';
          
         $corpo_msg          = "Prezado(a) $nmprincipalparc, \n\nNo sistema de Avaliação de Desempenho, quanto à elaboração do plano de ação, constam pendências em seu nome.\n\n".
                "Suas pendências:\n\n".
                $str_equipe."Atenciosamente,\n$nome_remetente.";
         //$corpo_msg          = "Prezado(a) $nmprincipalparc, \n\nNo sistema de Avalia��o de Desempenho, quanto � elabora��o do plano de a��o, constam pend�ncias em seu nome.\n\n".
         //       "Suas pend�ncias:\n\n".
         //                     $str_equipe."\n\nInformamos ainda que foi disponibilizado um menu AJUDA contendo um tutorial PASSO A PASSO e um canal de comunica��o chamado D�VIDAS E SUGEST�ES.\n\n".
         //                    "HOJE � O �LTIMO DIA PARA A CONCLUS�O DO PLANO DE A��O, REGULARIZE-SE\n\nAtenciosamente,\n$nome_remetente.";
//          $corpo_msg = "Prezado(a) $nmprincipalparc, \n\nNo sistema de Avalia��o de Desempenho, quanto ao prazo de conclus�o das a��es, constam datas j� expiradas.\n\n".
//                        "Suas pend�ncias:\n\n".
//                        $str_equipe."Atenciosamente,\n$nome_remetente.";
          $nome_destinatario  = $nmprincipalparc;
          
            if ($email === null) {

                $nmOperExplode      = explode(' ', $nmprincipalparc);
                $primeiroNmOperador = strtolower(array_shift($nmOperExplode));
                $ultimoNmOperador   = strtolower(array_pop($nmOperExplode));
                $email_destinatario = "$primeiroNmOperador.$ultimoNmOperador@teknisa.com";
                $email_destinatario = strtr(utf8_decode($email_destinatario), utf8_decode("��������������"), "aaaaeeiooouucn");
                $email_destinatario = utf8_encode($email_destinatario);
            }
            else {
                $email_destinatario = $email;
            }
            
            if (($email_destinatario === null) || ($email_destinatario === false)) {
                
             $colabSemEmail[$key] = $nmprincipalparc;
            }
          try {
              
            $arrayDestinatario = array($emailOperadorLogado);
            $arrayCc           = array($emailOperadorLogado); 
            
            $this->enviaZendMail($emailOperadorLogado, $nomeOperadorLogado,  //De/From
                                 $corpo_msg, 
                                 $arrayDestinatario,   $nome_destinatario,   //Destinat�rio/To
                                 $arrayCc,             $nomeOperadorLogado,  //Copia/Cc
                                 $assunto);
            
            $cont++;
       }catch (Exception $e) {
           
            $contFail++;
       }
     
       $arrayMensagens = array('QTDLIDERES'  => $qtdLideres, 'QTDLIDERADOS' => $qtdLiderados,
                               'QTDENVIADOS' => $cont,           'QTDERROS' => $contFail,
                               'ARRAY'       => $colabSemEmail);
     
        return $arrayMensagens;
      }
   }
   
   public function dataDefaultLogic($nrparcavaliado){
       
       $avaliacaogeralRepository = \Avaliacao\Entities\Avaliacaogeral::getRepository();
       $data = $avaliacaogeralRepository->dataDefaultLogicRepository($nrparcavaliado);
       
       return $data[0]['DTINIREALIZAVAL'];
   }

    /**
     *  Importa os relacionamentos baseando nas movimentações, na hierarquia e tipo de relacionamento definidos no filtro
     *
     * @author leonardocarvalho - 07/11/2014
     */
   public function importarRelarionamentosByHierarquia($nrAvaliacao, $nrTipohierarqorg, $nrTiporelaciona,
                                                       $avaliador, $avaliado, $nrOcupacao, $dsOrdem,
                                                       $dsInicio, $dsFim, $nrOrg, $nrParceiro) {

       set_time_limit(100000);
       $totalRelacionamentos = 0;

       // retorna combinação de questões
       /** @var $combQuestaval \Avaliacao\Entities\Combquestaval */
       $combQuestaval = \Avaliacao\Entities\Combquestaval::findOneByNrorgAndNravaliacao($nrOrg, $nrAvaliacao);
       if (!is_object($combQuestaval)) {
           $combQuestaval = \Avaliacao\Entities\Combquestaval::findOneByNrorgAndNravaliacaoAndNrcombquestaval($nrOrg, null, '1');
       }

       $mesCompetencia = FPA::getDtCompetencia();
       $this->_vinculom = new \GpevinculomEntity();

       // Retorna todos os vinculos ativos na competência
       $vinculos = $this->_vinculom->retornaVinculosAtivosMesCompetencia($nrOrg, $mesCompetencia, $dsInicio,
                                                                         $dsFim, $dsOrdem, false, null, false);

       // Retorna hierarquia da organização
       /** @var $hierarquia \TipohierarqorgEntity */
       $hierarquia = \Tipohierarqorg::retornaTipoHierarquia(FPA::getNrorgPadrao(), $nrOrg, $nrTipohierarqorg);
       // $nrTipoestrutura = $hierarquia->getNrtipoestrutsup();
       $nrTipoestrutura = $hierarquia->getNrtipoestrutrel();
       
	   // vari�vel para controle de commit
       $countCommit = 0;
       \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();

       // Percorre os vinculos gerando os relacionamentos
       /** @var $vinculo \GpevinculomEntity */
       foreach ($vinculos as $vinculo) {

           if ($nrOcupacao) {
               $nrCargo = $vinculo->getUltimoHistoricoCompetencia($mesCompetencia)->getNrcargo();
               if ($nrOcupacao != $nrCargo)
                   continue;
           }

           // retonas a última movimentação gerencial do vínculo com a estrutura relacionada da hierarquia
           $movimentacaoGeren = \Gpemovimentacao::getUltimaMovimentacaoPorTipo($nrOrg, $nrTipoestrutura, $vinculo->getNrvinculom());
           if ($movimentacaoGeren) {

               if ($movimentacaoGeren->getEstrutura()) {

                   // retorna parceiro de negocio da pessoa responsável informal pela estrutura
                   $nrParcrespinf = $movimentacaoGeren->getEstrutura()->getHistorico()->getNrparcrespinf();
                   if (!$nrParcrespinf) {
                       throw new \Exception('Estrutura '. $movimentacaoGeren->getEstrutura()->getNrestruturam() .' não possui \'Pessoa Responsável Informal.\'');
                   }

                   // retorna pessoa do vinculo
                   /** @var $gpePessoa \Folha\Entities\GpePessoa */
                   $gpePessoa = \Folha\Entities\GpePessoa::findOneByNrorgAndNrpessoa($nrOrg, $vinculo->getNrpessoa());

                   // verifica tipo de relacionamento a ser importado
                   switch ($nrTiporelaciona) {
                       case Tiporelaciona::AVL_AUTOAVALIACAO:

                           // define lider e liderado
                           $lider = $gpePessoa->getNrparcnegocio();
                           $liderado = $gpePessoa->getNrparcnegocio();

                           // verifica se já existe relacionamento entre a organização, a avaliacao, a combinação, o lider e o liderado
                           $participaval = \Avaliacao\Entities\Participaval::findOneByNrorgAndNravaliacaoAndNrcombquestavalAndNrtiporelacionaAndNrparcexecavalAndNrparcavaliado($nrOrg, $nrAvaliacao, $combQuestaval->getNrcombquestaval(), $nrTiporelaciona, $lider, $liderado);
                           if (!$participaval) {
                               // Insere relacionamento na participaval
                               $this->insereParticipaval($nrOrg, $nrAvaliacao, $liderado, $lider, $nrTiporelaciona, $combQuestaval->getNrcombquestaval());
                               
							   // controle para commit dos registros inseridos
                               if ($countCommit == 10){
                                   \Setforms2\Shared\Registry::getEntityManager()->commit();
                                   \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
                                   $countCommit = 0;
                               }

                               $countCommit++;
                               $totalRelacionamentos++;
                           }
                           break;

                       case Tiporelaciona::AVL_LIDER:

                           // define lider e liderado
                           $lider = $nrParcrespinf;
                           $liderado = $gpePessoa->getNrparcnegocio();

                           // verifica se já existe relacionamento entre a organização, a avaliacao, a combinação, o lider e o liderado
                           $participaval = \Avaliacao\Entities\Participaval::findOneByNrorgAndNravaliacaoAndNrcombquestavalAndNrtiporelacionaAndNrparcexecavalAndNrparcavaliado($nrOrg, $nrAvaliacao, $combQuestaval->getNrcombquestaval(), $nrTiporelaciona, $lider, $liderado);
                           if (!$participaval) {
                               // Insere relacionamento na participaval
                               $this->insereParticipaval($nrOrg, $nrAvaliacao, $liderado, $lider, $nrTiporelaciona, $combQuestaval->getNrcombquestaval());
                               
							   // controle para commit dos registros inseridos
                               if ($countCommit == 10){
                                   \Setforms2\Shared\Registry::getEntityManager()->commit();
                                   \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
                                   $countCommit = 0;
                               }

                               $countCommit++;

                               $totalRelacionamentos++;
                           }
                           break;

                       case Tiporelaciona::AVL_LIDERADO:

                           // define lider e liderado
                           $lider = $gpePessoa->getNrparcnegocio();
                           $liderado = $nrParcrespinf;

                           // verifica se já existe relacionamento entre a organização, a avaliacao, a combinação, o lider e o liderado
                           $participaval = \Avaliacao\Entities\Participaval::findOneByNrorgAndNravaliacaoAndNrcombquestavalAndNrtiporelacionaAndNrparcexecavalAndNrparcavaliado($nrOrg, $nrAvaliacao, $combQuestaval->getNrcombquestaval(), $nrTiporelaciona, $lider, $liderado);
                           if (!$participaval) {
                               // Insere relacionamento na participaval
                               $this->insereParticipaval($nrOrg, $nrAvaliacao, $liderado, $lider, $nrTiporelaciona, $combQuestaval->getNrcombquestaval());
                               
							   // controle para commit dos registros inseridos
                               if ($countCommit == 10){
                                   \Setforms2\Shared\Registry::getEntityManager()->commit();
                                   \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
                                   $countCommit = 0;
                               }

                               $countCommit++;
                               $totalRelacionamentos++;
                           }
                           break;

                       case Tiporelaciona::AVL_PARCEIRO:

                           // define lider e liderado
                           $lider = $gpePessoa->getNrparcnegocio();
                           $liderado = $nrParceiro;

                           // verifica se já existe relacionamento entre a organização, a avaliacao, a combinação, o lider e o liderado
                           $participaval = \Avaliacao\Entities\Participaval::findOneByNrorgAndNravaliacaoAndNrcombquestavalAndNrtiporelacionaAndNrparcexecavalAndNrparcavaliado($nrOrg, $nrAvaliacao, $combQuestaval->getNrcombquestaval(), $nrTiporelaciona, $lider, $liderado);
                           if (!$participaval) {
                               // Insere relacionamento na participaval                                       
                               $this->insereParticipaval($nrOrg, $nrAvaliacao, $liderado, $lider, $nrTiporelaciona, $combQuestaval->getNrcombquestaval());                               
                            
							   // controle para commit dos registros inseridos
                               if ($countCommit == 10){
                                   \Setforms2\Shared\Registry::getEntityManager()->commit();
                                   \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
                                   $countCommit = 0;
                               }

                               $countCommit++;
                               $totalRelacionamentos++;
                           }
                           break;
                   }

                   // retorna estrutura superior da relacionada pela hierarquia
//                   $estruturaSuperior = $movimentacaoGeren->getEstrutura()->getEstruturaSuperior($nrTipohierarqorg);
//                   if ($estruturaSuperior) {
//                       tk_warning('Estrutura Superior: '.$estruturaSuperior->getHistorico()->getNrparcrespinf());
//                   } else {
//                      tk_warning('Hierarquia não encontrada para a estrutura '. $movimentacaoGeren->getNrestruturam() .' e tipo de hierarquia '. $nrTipohierarqorg);
//                   }

               } else {
                   tk_warning('Movimentação '. $movimentacaoGeren->getNrmovimentacao() .' do vínculo ' . $vinculo->getNmvinculom() . ' não possui estrutura.');
               }
           } else {
               tk_warning('Vínculo ' . $vinculo->getNmvinculom() . ' não possui movimentação gerencial para hierarquia.');
           }
       }
		
	   // commit para o �ltimo registro
       \Setforms2\Shared\Registry::getEntityManager()->commit();                                                                
       return $totalRelacionamentos;

   }

    /**
     * Insere os relacionamentos da Participaval
     *
     * @param $nrOrg
     * @param $nrAvaliacao
     * @param $liderado
     * @param $lider
     * @param $nrTiporelaciona
     * @param $nrCombQuestParam
     * @throws Exception
     * @throws \Exception
     *
     * @author leonardocarvalho - 10/11/2014
     */
    private function insereParticipaval($nrOrg, $nrAvaliacao, $liderado, $lider, $nrTiporelaciona, $nrCombQuestParam) {

       try {
           // retorna novo código para Participaval
           $novoCodigo = \Geral\Util\NovoCodigo::geraCodigo($nrOrg,'PARTICIPAVAL', 1, 10, true);

           // insere relacionamento da Participaval
           $participaval =  new \Avaliacao\Entities\Participaval();
           $participaval->insert(
               $nrparticipaval = $novoCodigo,
               $nrOrg,
               $nrAvaliacao,
               $liderado       = $liderado,
               $lider          = $lider,
               $nrTiporelaciona,
               $nrCombQuestParam     = $nrCombQuestParam,
               $vrresultavalia  = null,
               $dtinclusao      = \Geral\Util\DateUtil::getDataAtual(),
               $dtultatu        = null,
               $nrorginclusao   = $nrOrg,
               $cdoperinclusao  = Ambiente::getCdOperador(),
               $nrorgultatu     = $nrOrg,
               $cdoperultatu    = null,
               $cdtiporesu      = null,
               $dtconclusaoaval = null,
               $idsituacaoaval  = \Avaliacao\Entities\Participaval::STATUS_PENDENTE,
               $idativo         = 'S');

           \Setforms2\Shared\Registry::getEntityManager()->flush();

       }   catch (Exception $e) {
           throw $e;
       }

   }

    /**
     * verifica se existe mais de um relacionamento com pesos diferentes
     *
     * @param $nravaliacao
     * @param $nrorg
     * @return bool
     */
    private function relacionamentosPesoDiferente($nravaliacao, $nrorg)
    {
        $paramsRelacionamentosPesoDiferente = array('P_NRAVALIACAO' => $nravaliacao,
                                                    'P_NRORG' => $nrorg);

        $paramRelacionamento = \Geral\Entities\Tiporelacaval::relacionamentosPesoDiferente($paramsRelacionamentosPesoDiferente);
        if (empty($paramRelacionamento[0]['CONTADOR'])) {
            return false;
        } else {
            return true;
        }
    }

}
