<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 27/01/14
 * Time: 15:45
 */

namespace Folha\Facade\Relatorios;


class Obrigacao {
    /**
     * Verifica se os fields estão corretamente preenchidos de acordo com o relatório selecionado
     * pck 27/01/2013
     */
    public static function verificaFields() {
        switch(tk_get_field_value('REPORT_NAME')) {  //Nome do relatório
            case '':    //Nenhum relatório selecionado
                tk_abort('Nenhum relatório selecionado.');
                break;
            case 'gps':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar o Tipo de Movimento, a Modalidade (Cenários) e o Tipo de Estrutura para emitir a GPS');
                break;
            case 'gps_desoneracao':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar o Tipo de Movimento, a Modalidade (Cenários) e o Tipo de Estrutura para emitir a GPS');
                break;
            case 'darf':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar o Tipo de Movimento, a Modalidade (Cenários) e o Tipo de Estrutura para emitir a DARF');
                if(tk_get_field_value('MULTA') == null)
                    tk_set_field_value('MULTA','0,00');
                if(tk_get_field_value('JUROSENCARGOS') == null)
                    tk_set_field_value('JUROSENCARGOS','0,00');
                if(tk_get_field_value('DTVENCIMENTO') == null /*|| tk_get_field_value('CODIGORECEITA') == null*/ || tk_get_field_value('PERIODOAPURACAO') == null ) //Rafael Pickbrenner Fora de uso 06/04/2015
                    tk_abort('É necessário informar o valor da Multa, Juros e Encargos, a Data de Vencimentos, o Código da Receita e o período de Apuração para emitir a DARF');
                break;
            case 'darf_desoneracao':
                if(tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('ESTRUTLEGAL') == null || tk_get_field_value('CODIGORECEITA') == null )
                    tk_abort('É necessário informar o Tipo de Modalidade (Cenários), a Estrutura Legal e o Código da Receita para emitir a DARF');
                if(tk_get_field_value('MULTA') == null)
                    tk_set_field_value('MULTA','0,00');
                if(tk_get_field_value('JUROSENCARGOS') == null)
                    tk_set_field_value('JUROSENCARGOS','0,00');
                break;
            default:
                tk_abort('Este relatório não está integrado');
        }
    }
} 